//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class CompilationUnitImpl implements CompilationUnit{
    CompilationUnitImpl(de.peeeq.wurstscript.attributes.CompilationUnitInfo cuInfo, JassToplevelDeclarations jassDecls, WPackages packages) {
        if (cuInfo == null)
            throw new IllegalArgumentException("Element cuInfo must not be null.");
        if (jassDecls == null)
            throw new IllegalArgumentException("Element jassDecls must not be null.");
        if (packages == null)
            throw new IllegalArgumentException("Element packages must not be null.");
        this.cuInfo = cuInfo;
        this.jassDecls = jassDecls;
        this.packages = packages;
        jassDecls.setParent(this);
        packages.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.attributes.CompilationUnitInfo cuInfo;
    public void setCuInfo(de.peeeq.wurstscript.attributes.CompilationUnitInfo cuInfo) {
        if (cuInfo == null) throw new IllegalArgumentException();
        this.cuInfo = cuInfo;
    } 
    public de.peeeq.wurstscript.attributes.CompilationUnitInfo getCuInfo() { return cuInfo; }

    private JassToplevelDeclarations jassDecls;
    public void setJassDecls(JassToplevelDeclarations jassDecls) {
        if (jassDecls == null) throw new IllegalArgumentException();
        this.jassDecls.setParent(null);
        jassDecls.setParent(this);
        this.jassDecls = jassDecls;
    } 
    public JassToplevelDeclarations getJassDecls() { return jassDecls; }

    private WPackages packages;
    public void setPackages(WPackages packages) {
        if (packages == null) throw new IllegalArgumentException();
        this.packages.setParent(null);
        packages.setParent(this);
        this.packages = packages;
    } 
    public WPackages getPackages() { return packages; }

    public Element get(int i) {
        switch (i) {
            case 0: return jassDecls;
            case 1: return packages;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = jassDecls; setJassDecls((JassToplevelDeclarations) newElem); return oldElem;
            case 1: oldElem = packages; setPackages((WPackages) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.jassDecls);
        action.accept(this.packages);
    }
    public int size() {
        return 2;
    }
    @Override public CompilationUnit copy() {
        CompilationUnit result = new CompilationUnitImpl(cuInfo, (JassToplevelDeclarations) this.jassDecls.copy(), (WPackages) this.packages.copy());
        return result;
    }

    @Override public CompilationUnit copyWithRefs() {
        CompilationUnit res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        jassDecls.clearAttributes();
        packages.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_attrReadVariables_state = 0;
        zzattr_attrNextScope_state = 0;
        zzattr_attrGetByType_state = 0;
        zzattr_attrNameLinks_state = 0;
        zzattr_attrTypeNameLinks_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(HasReadVariables.Matcher<T> matcher) {
        return matcher.case_CompilationUnit(this);
    }
    @Override public void match(HasReadVariables.MatcherVoid matcher) {
        matcher.case_CompilationUnit(this);
    }

    @Override public <T> T match(WScope.Matcher<T> matcher) {
        return matcher.case_CompilationUnit(this);
    }
    @Override public void match(WScope.MatcherVoid matcher) {
        matcher.case_CompilationUnit(this);
    }

    @Override public <T> T match(PackageOrGlobal.Matcher<T> matcher) {
        return matcher.case_CompilationUnit(this);
    }
    @Override public void match(PackageOrGlobal.MatcherVoid matcher) {
        matcher.case_CompilationUnit(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_CompilationUnit(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_CompilationUnit(this);
    }

    @Override public String toString() {
        return "CompilationUnit(" + cuInfo + ", " +jassDecls + ", " +packages+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof CompilationUnit) {
            CompilationUnit o = (CompilationUnit) e;
            return java.util.Objects.equals(cuInfo, o.getCuInfo())
                && this.jassDecls.structuralEquals(o.getJassDecls())
                && this.packages.structuralEquals(o.getPackages());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_attrReadVariables_state = 0;
    private de.peeeq.immutablecollections.ImmutableList<NameDef> zzattr_attrReadVariables_cache;
    /** */
    public de.peeeq.immutablecollections.ImmutableList<NameDef> attrReadVariables() {
        if (zzattr_attrReadVariables_state == 0) {
            try {
                zzattr_attrReadVariables_state = 1;
                zzattr_attrReadVariables_cache = de.peeeq.wurstscript.attributes.ReadVariables.calculate((CompilationUnit)this);
            } finally {
                zzattr_attrReadVariables_state = 0;
            }
            zzattr_attrReadVariables_state = 2;
        } else if (zzattr_attrReadVariables_state == 1) {
            throw new CyclicDependencyError(this, "attrReadVariables");
        }
        return zzattr_attrReadVariables_cache;
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((CompilationUnit)this);
    }
// circular = null
    private int zzattr_attrNextScope_state = 0;
    private @org.eclipse.jdt.annotation.Nullable WScope zzattr_attrNextScope_cache;
    /** "returns the scope surrounding this scope"*/
    public @org.eclipse.jdt.annotation.Nullable WScope attrNextScope() {
        if (zzattr_attrNextScope_state == 0) {
            try {
                zzattr_attrNextScope_state = 1;
                zzattr_attrNextScope_cache = de.peeeq.wurstscript.attributes.AttrNearest.nextScope((CompilationUnit)this);
            } finally {
                zzattr_attrNextScope_state = 0;
            }
            zzattr_attrNextScope_state = 2;
        } else if (zzattr_attrNextScope_state == 1) {
            throw new CyclicDependencyError(this, "attrNextScope");
        }
        return zzattr_attrNextScope_cache;
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((CompilationUnit)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((CompilationUnit)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((CompilationUnit)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((CompilationUnit)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((CompilationUnit)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((CompilationUnit)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((CompilationUnit)this);
    }
// circular = null
    private int zzattr_attrGetByType_state = 0;
    private de.peeeq.wurstscript.attributes.ByTypes zzattr_attrGetByType_cache;
    /** */
    public de.peeeq.wurstscript.attributes.ByTypes attrGetByType() {
        if (zzattr_attrGetByType_state == 0) {
            try {
                zzattr_attrGetByType_state = 1;
                zzattr_attrGetByType_cache = de.peeeq.wurstscript.attributes.GetByType.calculate((CompilationUnit)this);
            } finally {
                zzattr_attrGetByType_state = 0;
            }
            zzattr_attrGetByType_state = 2;
        } else if (zzattr_attrGetByType_state == 1) {
            throw new CyclicDependencyError(this, "attrGetByType");
        }
        return zzattr_attrGetByType_cache;
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((CompilationUnit)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((CompilationUnit)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((CompilationUnit)this);
    }
// circular = null
    private int zzattr_attrNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> zzattr_attrNameLinks_cache;
    /** "returns a map of all the names visible in this scope."*/
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> attrNameLinks() {
        if (zzattr_attrNameLinks_state == 0) {
            try {
                zzattr_attrNameLinks_state = 1;
                zzattr_attrNameLinks_cache = de.peeeq.wurstscript.attributes.names.NameLinks.calculate((CompilationUnit)this);
            } finally {
                zzattr_attrNameLinks_state = 0;
            }
            zzattr_attrNameLinks_state = 2;
        } else if (zzattr_attrNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrNameLinks");
        }
        return zzattr_attrNameLinks_cache;
    }
// circular = null
    private int zzattr_attrTypeNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> zzattr_attrTypeNameLinks_cache;
    /** "returns a map of all the names visible in this scope."*/
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> attrTypeNameLinks() {
        if (zzattr_attrTypeNameLinks_state == 0) {
            try {
                zzattr_attrTypeNameLinks_state = 1;
                zzattr_attrTypeNameLinks_cache = de.peeeq.wurstscript.attributes.names.TypeNameLinks.calculate((CompilationUnit)this);
            } finally {
                zzattr_attrTypeNameLinks_state = 0;
            }
            zzattr_attrTypeNameLinks_state = 2;
        } else if (zzattr_attrTypeNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrTypeNameLinks");
        }
        return zzattr_attrTypeNameLinks_cache;
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((CompilationUnit)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((CompilationUnit)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((CompilationUnit)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((CompilationUnit)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((CompilationUnit)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((CompilationUnit)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((CompilationUnit)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((CompilationUnit)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((CompilationUnit)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((CompilationUnit)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((CompilationUnit)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((CompilationUnit)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((CompilationUnit)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((CompilationUnit)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((CompilationUnit)this);
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((CompilationUnit)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((CompilationUnit)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((CompilationUnit)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((CompilationUnit)this, spacer, sb, indent);
    }
}
