//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class ExprClosureImpl implements ExprClosure{
    ExprClosureImpl(de.peeeq.wurstscript.parser.WPos source, de.peeeq.wurstscript.parser.WPos arrowSource, WShortParameters shortParameters, Expr implementation) {
        if (source == null)
            throw new IllegalArgumentException("Element source must not be null.");
        if (arrowSource == null)
            throw new IllegalArgumentException("Element arrowSource must not be null.");
        if (shortParameters == null)
            throw new IllegalArgumentException("Element shortParameters must not be null.");
        if (implementation == null)
            throw new IllegalArgumentException("Element implementation must not be null.");
        this.source = source;
        this.arrowSource = arrowSource;
        this.shortParameters = shortParameters;
        this.implementation = implementation;
        shortParameters.setParent(this);
        implementation.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.parser.WPos source;
    public void setSource(de.peeeq.wurstscript.parser.WPos source) {
        if (source == null) throw new IllegalArgumentException();
        this.source = source;
    } 
    public de.peeeq.wurstscript.parser.WPos getSource() { return source; }

    private de.peeeq.wurstscript.parser.WPos arrowSource;
    public void setArrowSource(de.peeeq.wurstscript.parser.WPos arrowSource) {
        if (arrowSource == null) throw new IllegalArgumentException();
        this.arrowSource = arrowSource;
    } 
    public de.peeeq.wurstscript.parser.WPos getArrowSource() { return arrowSource; }

    private WShortParameters shortParameters;
    public void setShortParameters(WShortParameters shortParameters) {
        if (shortParameters == null) throw new IllegalArgumentException();
        this.shortParameters.setParent(null);
        shortParameters.setParent(this);
        this.shortParameters = shortParameters;
    } 
    public WShortParameters getShortParameters() { return shortParameters; }

    private Expr implementation;
    public void setImplementation(Expr implementation) {
        if (implementation == null) throw new IllegalArgumentException();
        this.implementation.setParent(null);
        implementation.setParent(this);
        this.implementation = implementation;
    } 
    public Expr getImplementation() { return implementation; }

    public Element get(int i) {
        switch (i) {
            case 0: return shortParameters;
            case 1: return implementation;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = shortParameters; setShortParameters((WShortParameters) newElem); return oldElem;
            case 1: oldElem = implementation; setImplementation((Expr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.shortParameters);
        action.accept(this.implementation);
    }
    public int size() {
        return 2;
    }
    @Override public ExprClosure copy() {
        ExprClosure result = new ExprClosureImpl(source, arrowSource, (WShortParameters) this.shortParameters.copy(), (Expr) this.implementation.copy());
        return result;
    }

    @Override public ExprClosure copyWithRefs() {
        ExprClosure res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        shortParameters.clearAttributes();
        implementation.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_attrReadVariables_state = 0;
        zzattr_attrTyp_state = 0;
        zzattr_attrConstantValue_state = 0;
        zzattr_attrTypRaw_state = 0;
        zzattr_attrExpectedTypRaw_state = 0;
        zzattr_attrExpectedTyp_state = 0;
        zzattr_attrClosureAbstractMethod_state = 0;
        zzattr_attrCapturedVariables_state = 0;
        zzattr_attrNextScope_state = 0;
        zzattr_attrNameLinks_state = 0;
        zzattr_attrTypeNameLinks_state = 0;
        zzattr_attrUsedGlobalVariables_state = 0;
        zzattr_attrReadGlobalVariables_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(VarInitialization.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(VarInitialization.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(TranslatedToImFunction.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(TranslatedToImFunction.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(HasReadVariables.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(HasReadVariables.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(WScope.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(WScope.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(OptExpr.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(OptExpr.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(Expr.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(Expr.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(AstElementWithSource.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(AstElementWithSource.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public <T> T match(ExprOrStatements.Matcher<T> matcher) {
        return matcher.case_ExprClosure(this);
    }
    @Override public void match(ExprOrStatements.MatcherVoid matcher) {
        matcher.case_ExprClosure(this);
    }

    @Override public String toString() {
        return "ExprClosure(" + source + ", " +arrowSource + ", " +shortParameters + ", " +implementation+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof ExprClosure) {
            ExprClosure o = (ExprClosure) e;
            return this.shortParameters.structuralEquals(o.getShortParameters())
                && this.implementation.structuralEquals(o.getImplementation());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_attrReadVariables_state = 0;
    private de.peeeq.immutablecollections.ImmutableList<NameDef> zzattr_attrReadVariables_cache;
    /** */
    public de.peeeq.immutablecollections.ImmutableList<NameDef> attrReadVariables() {
        if (zzattr_attrReadVariables_state == 0) {
            try {
                zzattr_attrReadVariables_state = 1;
                zzattr_attrReadVariables_cache = de.peeeq.wurstscript.attributes.ReadVariables.calculate((ExprClosure)this);
            } finally {
                zzattr_attrReadVariables_state = 0;
            }
            zzattr_attrReadVariables_state = 2;
        } else if (zzattr_attrReadVariables_state == 1) {
            throw new CyclicDependencyError(this, "attrReadVariables");
        }
        return zzattr_attrReadVariables_cache;
    }
// circular = null
    private int zzattr_attrTyp_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrTyp_cache;
    /** */
    public de.peeeq.wurstscript.types.WurstType attrTyp() {
        if (zzattr_attrTyp_state == 0) {
            try {
                zzattr_attrTyp_state = 1;
                zzattr_attrTyp_cache = de.peeeq.wurstscript.attributes.AttrExprType.normalizedType((ExprClosure)this);
            } finally {
                zzattr_attrTyp_state = 0;
            }
            zzattr_attrTyp_state = 2;
        } else if (zzattr_attrTyp_state == 1) {
            throw new CyclicDependencyError(this, "attrTyp");
        }
        return zzattr_attrTyp_cache;
    }
// circular = null
    private int zzattr_attrConstantValue_state = 0;
    private de.peeeq.wurstscript.intermediatelang.ILconst zzattr_attrConstantValue_cache;
    /** */
    public de.peeeq.wurstscript.intermediatelang.ILconst attrConstantValue() {
        if (zzattr_attrConstantValue_state == 0) {
            try {
                zzattr_attrConstantValue_state = 1;
                zzattr_attrConstantValue_cache = de.peeeq.wurstscript.attributes.AttrConstantValue.calculate((ExprClosure)this);
            } finally {
                zzattr_attrConstantValue_state = 0;
            }
            zzattr_attrConstantValue_state = 2;
        } else if (zzattr_attrConstantValue_state == 1) {
            throw new CyclicDependencyError(this, "attrConstantValue");
        }
        return zzattr_attrConstantValue_cache;
    }
// circular = null
    private int zzattr_attrTypRaw_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrTypRaw_cache;
    /** */
    public de.peeeq.wurstscript.types.WurstType attrTypRaw() {
        if (zzattr_attrTypRaw_state == 0) {
            try {
                zzattr_attrTypRaw_state = 1;
                zzattr_attrTypRaw_cache = de.peeeq.wurstscript.attributes.AttrExprType.calculate((ExprClosure)this);
            } finally {
                zzattr_attrTypRaw_state = 0;
            }
            zzattr_attrTypRaw_state = 2;
        } else if (zzattr_attrTypRaw_state == 1) {
            throw new CyclicDependencyError(this, "attrTypRaw");
        }
        return zzattr_attrTypRaw_cache;
    }
// circular = null
    private int zzattr_attrExpectedTypRaw_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrExpectedTypRaw_cache;
    /** */
    public de.peeeq.wurstscript.types.WurstType attrExpectedTypRaw() {
        if (zzattr_attrExpectedTypRaw_state == 0) {
            try {
                zzattr_attrExpectedTypRaw_state = 1;
                zzattr_attrExpectedTypRaw_cache = de.peeeq.wurstscript.attributes.AttrExprExpectedType.calculate((ExprClosure)this);
            } finally {
                zzattr_attrExpectedTypRaw_state = 0;
            }
            zzattr_attrExpectedTypRaw_state = 2;
        } else if (zzattr_attrExpectedTypRaw_state == 1) {
            throw new CyclicDependencyError(this, "attrExpectedTypRaw");
        }
        return zzattr_attrExpectedTypRaw_cache;
    }
// circular = null
    private int zzattr_attrExpectedTyp_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrExpectedTyp_cache;
    /** "try to guess what type is expected here"*/
    public de.peeeq.wurstscript.types.WurstType attrExpectedTyp() {
        if (zzattr_attrExpectedTyp_state == 0) {
            try {
                zzattr_attrExpectedTyp_state = 1;
                zzattr_attrExpectedTyp_cache = de.peeeq.wurstscript.attributes.AttrExprExpectedType.normalizedType((ExprClosure)this);
            } finally {
                zzattr_attrExpectedTyp_state = 0;
            }
            zzattr_attrExpectedTyp_state = 2;
        } else if (zzattr_attrExpectedTyp_state == 1) {
            throw new CyclicDependencyError(this, "attrExpectedTyp");
        }
        return zzattr_attrExpectedTyp_cache;
    }
    /** "more precise expected type, after overloading"*/
    public de.peeeq.wurstscript.types.WurstType attrExpectedTypAfterOverloading() {
        return de.peeeq.wurstscript.attributes.AttrExprExpectedType.afterOverloading((ExprClosure)this);
    }
// circular = null
    private int zzattr_attrClosureAbstractMethod_state = 0;
    private de.peeeq.wurstscript.attributes.names.FuncLink zzattr_attrClosureAbstractMethod_cache;
    /** */
    public de.peeeq.wurstscript.attributes.names.FuncLink attrClosureAbstractMethod() {
        if (zzattr_attrClosureAbstractMethod_state == 0) {
            try {
                zzattr_attrClosureAbstractMethod_state = 1;
                zzattr_attrClosureAbstractMethod_cache = de.peeeq.wurstscript.attributes.AttrClosureAbstractMethod.calculate((ExprClosure)this);
            } finally {
                zzattr_attrClosureAbstractMethod_state = 0;
            }
            zzattr_attrClosureAbstractMethod_state = 2;
        } else if (zzattr_attrClosureAbstractMethod_state == 1) {
            throw new CyclicDependencyError(this, "attrClosureAbstractMethod");
        }
        return zzattr_attrClosureAbstractMethod_cache;
    }
// circular = null
    private int zzattr_attrCapturedVariables_state = 0;
    private com.google.common.collect.ImmutableMultimap<Element, VarDef> zzattr_attrCapturedVariables_cache;
    /** */
    public com.google.common.collect.ImmutableMultimap<Element, VarDef> attrCapturedVariables() {
        if (zzattr_attrCapturedVariables_state == 0) {
            try {
                zzattr_attrCapturedVariables_state = 1;
                zzattr_attrCapturedVariables_cache = de.peeeq.wurstscript.attributes.AttrClosureCapturedVariables.calculate((ExprClosure)this);
            } finally {
                zzattr_attrCapturedVariables_state = 0;
            }
            zzattr_attrCapturedVariables_state = 2;
        } else if (zzattr_attrCapturedVariables_state == 1) {
            throw new CyclicDependencyError(this, "attrCapturedVariables");
        }
        return zzattr_attrCapturedVariables_cache;
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((ExprClosure)this);
    }
// circular = null
    private int zzattr_attrNextScope_state = 0;
    private @org.eclipse.jdt.annotation.Nullable WScope zzattr_attrNextScope_cache;
    /** "returns the scope surrounding this scope"*/
    public @org.eclipse.jdt.annotation.Nullable WScope attrNextScope() {
        if (zzattr_attrNextScope_state == 0) {
            try {
                zzattr_attrNextScope_state = 1;
                zzattr_attrNextScope_cache = de.peeeq.wurstscript.attributes.AttrNearest.nextScope((ExprClosure)this);
            } finally {
                zzattr_attrNextScope_state = 0;
            }
            zzattr_attrNextScope_state = 2;
        } else if (zzattr_attrNextScope_state == 1) {
            throw new CyclicDependencyError(this, "attrNextScope");
        }
        return zzattr_attrNextScope_cache;
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((ExprClosure)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((ExprClosure)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((ExprClosure)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((ExprClosure)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((ExprClosure)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((ExprClosure)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((ExprClosure)this);
    }
    /** */
    public de.peeeq.wurstscript.jassIm.ImExpr imTranslateExpr(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.ExprTranslation.translate((ExprClosure)this, translator, f);
    }
    /** */
    public de.peeeq.wurstscript.jassIm.ImExprOpt imTranslateExprOpt(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.ExprTranslation.translate((ExprClosure)this, translator, f);
    }
    /** */
    public void imCreateFuncSkeleton(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        de.peeeq.wurstscript.translation.imtranslation.FuncSkeleton.create((ExprClosure)this, translator, f);
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((ExprClosure)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((ExprClosure)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((ExprClosure)this);
    }
// circular = null
    private int zzattr_attrNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> zzattr_attrNameLinks_cache;
    /** "returns a map of all the names visible in this scope."*/
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> attrNameLinks() {
        if (zzattr_attrNameLinks_state == 0) {
            try {
                zzattr_attrNameLinks_state = 1;
                zzattr_attrNameLinks_cache = de.peeeq.wurstscript.attributes.names.NameLinks.calculate((ExprClosure)this);
            } finally {
                zzattr_attrNameLinks_state = 0;
            }
            zzattr_attrNameLinks_state = 2;
        } else if (zzattr_attrNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrNameLinks");
        }
        return zzattr_attrNameLinks_cache;
    }
// circular = null
    private int zzattr_attrTypeNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> zzattr_attrTypeNameLinks_cache;
    /** "returns a map of all the names visible in this scope."*/
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> attrTypeNameLinks() {
        if (zzattr_attrTypeNameLinks_state == 0) {
            try {
                zzattr_attrTypeNameLinks_state = 1;
                zzattr_attrTypeNameLinks_cache = de.peeeq.wurstscript.attributes.names.TypeNameLinks.calculate((ExprClosure)this);
            } finally {
                zzattr_attrTypeNameLinks_state = 0;
            }
            zzattr_attrTypeNameLinks_state = 2;
        } else if (zzattr_attrTypeNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrTypeNameLinks");
        }
        return zzattr_attrTypeNameLinks_cache;
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((ExprClosure)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((ExprClosure)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((ExprClosure)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((ExprClosure)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((ExprClosure)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((ExprClosure)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((ExprClosure)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((ExprClosure)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((ExprClosure)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((ExprClosure)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((ExprClosure)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((ExprClosure)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((ExprClosure)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((ExprClosure)this, receiverType, name);
    }
// circular = de.peeeq.wurstscript.utils.Utils.emptyList
    private int zzattr_attrUsedGlobalVariables_state = 0;
    private com.google.common.collect.ImmutableList<VarDef> zzattr_attrUsedGlobalVariables_cache;
    /** */
    public com.google.common.collect.ImmutableList<VarDef> attrUsedGlobalVariables() {
        if (zzattr_attrUsedGlobalVariables_state == 0) {
            zzattr_attrUsedGlobalVariables_state = 1;
            zzattr_attrUsedGlobalVariables_cache = de.peeeq.wurstscript.utils.Utils.emptyList();
            while (true) {
                com.google.common.collect.ImmutableList<VarDef> r = de.peeeq.wurstscript.attributes.UsedGlobalVariables.getUsedGlobals((ExprClosure)this);
                if (zzattr_attrUsedGlobalVariables_state == 3) {
                    if (!zzattr_attrUsedGlobalVariables_cache.equals(r)) {
                        zzattr_attrUsedGlobalVariables_cache = r;
                        continue;
                    }
                }
                zzattr_attrUsedGlobalVariables_cache = r;
                break;
            }
            zzattr_attrUsedGlobalVariables_state = 2;
        } else if (zzattr_attrUsedGlobalVariables_state == 1) {
            zzattr_attrUsedGlobalVariables_state = 3;
        }
        return zzattr_attrUsedGlobalVariables_cache;
    }
// circular = de.peeeq.wurstscript.utils.Utils.emptyList
    private int zzattr_attrReadGlobalVariables_state = 0;
    private com.google.common.collect.ImmutableList<VarDef> zzattr_attrReadGlobalVariables_cache;
    /** */
    public com.google.common.collect.ImmutableList<VarDef> attrReadGlobalVariables() {
        if (zzattr_attrReadGlobalVariables_state == 0) {
            zzattr_attrReadGlobalVariables_state = 1;
            zzattr_attrReadGlobalVariables_cache = de.peeeq.wurstscript.utils.Utils.emptyList();
            while (true) {
                com.google.common.collect.ImmutableList<VarDef> r = de.peeeq.wurstscript.attributes.UsedGlobalVariables.getReadGlobals((ExprClosure)this);
                if (zzattr_attrReadGlobalVariables_state == 3) {
                    if (!zzattr_attrReadGlobalVariables_cache.equals(r)) {
                        zzattr_attrReadGlobalVariables_cache = r;
                        continue;
                    }
                }
                zzattr_attrReadGlobalVariables_cache = r;
                break;
            }
            zzattr_attrReadGlobalVariables_state = 2;
        } else if (zzattr_attrReadGlobalVariables_state == 1) {
            zzattr_attrReadGlobalVariables_state = 3;
        }
        return zzattr_attrReadGlobalVariables_cache;
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((ExprClosure)this);
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((ExprClosure)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((ExprClosure)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((ExprClosure)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((ExprClosure)this, spacer, sb, indent);
    }
}
