//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class IdentifierWithTypeArgsImpl implements IdentifierWithTypeArgs{
    IdentifierWithTypeArgsImpl(de.peeeq.wurstscript.parser.WPos source, Identifier nameId, TypeExprList typeArgs) {
        if (source == null)
            throw new IllegalArgumentException("Element source must not be null.");
        if (nameId == null)
            throw new IllegalArgumentException("Element nameId must not be null.");
        if (typeArgs == null)
            throw new IllegalArgumentException("Element typeArgs must not be null.");
        this.source = source;
        this.nameId = nameId;
        this.typeArgs = typeArgs;
        nameId.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.parser.WPos source;
    public void setSource(de.peeeq.wurstscript.parser.WPos source) {
        if (source == null) throw new IllegalArgumentException();
        this.source = source;
    } 
    public de.peeeq.wurstscript.parser.WPos getSource() { return source; }

    private Identifier nameId;
    public void setNameId(Identifier nameId) {
        if (nameId == null) throw new IllegalArgumentException();
        this.nameId.setParent(null);
        nameId.setParent(this);
        this.nameId = nameId;
    } 
    public Identifier getNameId() { return nameId; }

    private TypeExprList typeArgs;
    public void setTypeArgs(TypeExprList typeArgs) {
        if (typeArgs == null) throw new IllegalArgumentException();
        this.typeArgs = typeArgs;
    } 
    public TypeExprList getTypeArgs() { return typeArgs; }

    public Element get(int i) {
        switch (i) {
            case 0: return nameId;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = nameId; setNameId((Identifier) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.nameId);
    }
    public int size() {
        return 1;
    }
    @Override public IdentifierWithTypeArgs copy() {
        IdentifierWithTypeArgs result = new IdentifierWithTypeArgsImpl(source, (Identifier) this.nameId.copy(), typeArgs);
        return result;
    }

    @Override public IdentifierWithTypeArgs copyWithRefs() {
        IdentifierWithTypeArgs res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        nameId.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(AstElementWithTypeArgs.Matcher<T> matcher) {
        return matcher.case_IdentifierWithTypeArgs(this);
    }
    @Override public void match(AstElementWithTypeArgs.MatcherVoid matcher) {
        matcher.case_IdentifierWithTypeArgs(this);
    }

    @Override public <T> T match(AstElementWithSource.Matcher<T> matcher) {
        return matcher.case_IdentifierWithTypeArgs(this);
    }
    @Override public void match(AstElementWithSource.MatcherVoid matcher) {
        matcher.case_IdentifierWithTypeArgs(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_IdentifierWithTypeArgs(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_IdentifierWithTypeArgs(this);
    }

    @Override public <T> T match(AstElementWithNameId.Matcher<T> matcher) {
        return matcher.case_IdentifierWithTypeArgs(this);
    }
    @Override public void match(AstElementWithNameId.MatcherVoid matcher) {
        matcher.case_IdentifierWithTypeArgs(this);
    }

    @Override public String toString() {
        return "IdentifierWithTypeArgs(" + source + ", " +nameId + ", " +typeArgs+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof IdentifierWithTypeArgs) {
            IdentifierWithTypeArgs o = (IdentifierWithTypeArgs) e;
            return this.nameId.structuralEquals(o.getNameId())
                && this.typeArgs == o.getTypeArgs();
        } else {
            return false;
        }
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((IdentifierWithTypeArgs)this);
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((IdentifierWithTypeArgs)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((IdentifierWithTypeArgs)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((IdentifierWithTypeArgs)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((IdentifierWithTypeArgs)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((IdentifierWithTypeArgs)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((IdentifierWithTypeArgs)this);
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((IdentifierWithTypeArgs)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((IdentifierWithTypeArgs)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((IdentifierWithTypeArgs)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((IdentifierWithTypeArgs)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((IdentifierWithTypeArgs)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((IdentifierWithTypeArgs)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((IdentifierWithTypeArgs)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((IdentifierWithTypeArgs)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((IdentifierWithTypeArgs)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((IdentifierWithTypeArgs)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((IdentifierWithTypeArgs)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((IdentifierWithTypeArgs)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((IdentifierWithTypeArgs)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((IdentifierWithTypeArgs)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((IdentifierWithTypeArgs)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((IdentifierWithTypeArgs)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((IdentifierWithTypeArgs)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((IdentifierWithTypeArgs)this);
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((IdentifierWithTypeArgs)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((IdentifierWithTypeArgs)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((IdentifierWithTypeArgs)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((IdentifierWithTypeArgs)this, spacer, sb, indent);
    }
}
