//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class StmtLoopImpl implements StmtLoop{
    StmtLoopImpl(de.peeeq.wurstscript.parser.WPos source, WStatements body) {
        if (source == null)
            throw new IllegalArgumentException("Element source must not be null.");
        if (body == null)
            throw new IllegalArgumentException("Element body must not be null.");
        this.source = source;
        this.body = body;
        body.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.parser.WPos source;
    public void setSource(de.peeeq.wurstscript.parser.WPos source) {
        if (source == null) throw new IllegalArgumentException();
        this.source = source;
    } 
    public de.peeeq.wurstscript.parser.WPos getSource() { return source; }

    private WStatements body;
    public void setBody(WStatements body) {
        if (body == null) throw new IllegalArgumentException();
        this.body.setParent(null);
        body.setParent(this);
        this.body = body;
    } 
    public WStatements getBody() { return body; }

    public Element get(int i) {
        switch (i) {
            case 0: return body;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = body; setBody((WStatements) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.body);
    }
    public int size() {
        return 1;
    }
    @Override public StmtLoop copy() {
        StmtLoop result = new StmtLoopImpl(source, (WStatements) this.body.copy());
        return result;
    }

    @Override public StmtLoop copyWithRefs() {
        StmtLoop res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        body.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_attrNextStatements_state = 0;
        zzattr_attrPreviousStatements_state = 0;
        zzattr_attrAfterBodyStatements_state = 0;
        zzattr_attrListIndex_state = 0;
        zzattr_attrReadVariables_state = 0;
        zzattr_attrUsedGlobalVariables_state = 0;
        zzattr_attrReadGlobalVariables_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(ControlflowStatement.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(ControlflowStatement.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(HasReadVariables.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(HasReadVariables.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(CompoundStatement.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(CompoundStatement.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(AstElementWithBody.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(AstElementWithBody.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(AstElementWithSource.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(AstElementWithSource.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(WStatement.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(WStatement.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(ExprOrStatements.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(ExprOrStatements.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public <T> T match(LoopStatement.Matcher<T> matcher) {
        return matcher.case_StmtLoop(this);
    }
    @Override public void match(LoopStatement.MatcherVoid matcher) {
        matcher.case_StmtLoop(this);
    }

    @Override public String toString() {
        return "StmtLoop(" + source + ", " +body+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof StmtLoop) {
            StmtLoop o = (StmtLoop) e;
            return this.body.structuralEquals(o.getBody());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_attrNextStatements_state = 0;
    private java.util.List<WStatement> zzattr_attrNextStatements_cache;
    /** "returns all statements which can be executed after this statement"*/
    public java.util.List<WStatement> attrNextStatements() {
        if (zzattr_attrNextStatements_state == 0) {
            try {
                zzattr_attrNextStatements_state = 1;
                zzattr_attrNextStatements_cache = de.peeeq.wurstscript.attributes.Flow.getNext((StmtLoop)this);
            } finally {
                zzattr_attrNextStatements_state = 0;
            }
            zzattr_attrNextStatements_state = 2;
        } else if (zzattr_attrNextStatements_state == 1) {
            throw new CyclicDependencyError(this, "attrNextStatements");
        }
        return zzattr_attrNextStatements_cache;
    }
// circular = null
    private int zzattr_attrPreviousStatements_state = 0;
    private java.util.List<WStatement> zzattr_attrPreviousStatements_cache;
    /** "returns all statements which could have been executed before this statement"*/
    public java.util.List<WStatement> attrPreviousStatements() {
        if (zzattr_attrPreviousStatements_state == 0) {
            try {
                zzattr_attrPreviousStatements_state = 1;
                zzattr_attrPreviousStatements_cache = de.peeeq.wurstscript.attributes.Flow.getPrevious((StmtLoop)this);
            } finally {
                zzattr_attrPreviousStatements_state = 0;
            }
            zzattr_attrPreviousStatements_state = 2;
        } else if (zzattr_attrPreviousStatements_state == 1) {
            throw new CyclicDependencyError(this, "attrPreviousStatements");
        }
        return zzattr_attrPreviousStatements_cache;
    }
// circular = null
    private int zzattr_attrAfterBodyStatements_state = 0;
    private java.util.List<WStatement> zzattr_attrAfterBodyStatements_cache;
    /** "returns all statements which can be executed after the body/thenBlock/elseBlock of this statement is executed"*/
    public java.util.List<WStatement> attrAfterBodyStatements() {
        if (zzattr_attrAfterBodyStatements_state == 0) {
            try {
                zzattr_attrAfterBodyStatements_state = 1;
                zzattr_attrAfterBodyStatements_cache = de.peeeq.wurstscript.attributes.Flow.getAfterBody((StmtLoop)this);
            } finally {
                zzattr_attrAfterBodyStatements_state = 0;
            }
            zzattr_attrAfterBodyStatements_state = 2;
        } else if (zzattr_attrAfterBodyStatements_state == 1) {
            throw new CyclicDependencyError(this, "attrAfterBodyStatements");
        }
        return zzattr_attrAfterBodyStatements_cache;
    }
// circular = null
    private int zzattr_attrListIndex_state = 0;
    private int zzattr_attrListIndex_cache;
    /** "returns the index this statement has in the underlying list"*/
    public int attrListIndex() {
        if (zzattr_attrListIndex_state == 0) {
            try {
                zzattr_attrListIndex_state = 1;
                zzattr_attrListIndex_cache = de.peeeq.wurstscript.attributes.Flow.getListIndex((StmtLoop)this);
            } finally {
                zzattr_attrListIndex_state = 0;
            }
            zzattr_attrListIndex_state = 2;
        } else if (zzattr_attrListIndex_state == 1) {
            throw new CyclicDependencyError(this, "attrListIndex");
        }
        return zzattr_attrListIndex_cache;
    }
// circular = null
    private int zzattr_attrReadVariables_state = 0;
    private de.peeeq.immutablecollections.ImmutableList<NameDef> zzattr_attrReadVariables_cache;
    /** */
    public de.peeeq.immutablecollections.ImmutableList<NameDef> attrReadVariables() {
        if (zzattr_attrReadVariables_state == 0) {
            try {
                zzattr_attrReadVariables_state = 1;
                zzattr_attrReadVariables_cache = de.peeeq.wurstscript.attributes.ReadVariables.calculate((StmtLoop)this);
            } finally {
                zzattr_attrReadVariables_state = 0;
            }
            zzattr_attrReadVariables_state = 2;
        } else if (zzattr_attrReadVariables_state == 1) {
            throw new CyclicDependencyError(this, "attrReadVariables");
        }
        return zzattr_attrReadVariables_cache;
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((StmtLoop)this);
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((StmtLoop)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((StmtLoop)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((StmtLoop)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((StmtLoop)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((StmtLoop)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((StmtLoop)this);
    }
    /** */
    public de.peeeq.wurstscript.jassIm.ImStmt imTranslateStmt(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.StmtTranslation.translate((StmtLoop)this, translator, f);
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((StmtLoop)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((StmtLoop)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((StmtLoop)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((StmtLoop)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((StmtLoop)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((StmtLoop)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((StmtLoop)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((StmtLoop)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((StmtLoop)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((StmtLoop)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((StmtLoop)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((StmtLoop)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((StmtLoop)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((StmtLoop)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((StmtLoop)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((StmtLoop)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((StmtLoop)this, receiverType, name);
    }
// circular = de.peeeq.wurstscript.utils.Utils.emptyList
    private int zzattr_attrUsedGlobalVariables_state = 0;
    private com.google.common.collect.ImmutableList<VarDef> zzattr_attrUsedGlobalVariables_cache;
    /** */
    public com.google.common.collect.ImmutableList<VarDef> attrUsedGlobalVariables() {
        if (zzattr_attrUsedGlobalVariables_state == 0) {
            zzattr_attrUsedGlobalVariables_state = 1;
            zzattr_attrUsedGlobalVariables_cache = de.peeeq.wurstscript.utils.Utils.emptyList();
            while (true) {
                com.google.common.collect.ImmutableList<VarDef> r = de.peeeq.wurstscript.attributes.UsedGlobalVariables.getUsedGlobals((StmtLoop)this);
                if (zzattr_attrUsedGlobalVariables_state == 3) {
                    if (!zzattr_attrUsedGlobalVariables_cache.equals(r)) {
                        zzattr_attrUsedGlobalVariables_cache = r;
                        continue;
                    }
                }
                zzattr_attrUsedGlobalVariables_cache = r;
                break;
            }
            zzattr_attrUsedGlobalVariables_state = 2;
        } else if (zzattr_attrUsedGlobalVariables_state == 1) {
            zzattr_attrUsedGlobalVariables_state = 3;
        }
        return zzattr_attrUsedGlobalVariables_cache;
    }
// circular = de.peeeq.wurstscript.utils.Utils.emptyList
    private int zzattr_attrReadGlobalVariables_state = 0;
    private com.google.common.collect.ImmutableList<VarDef> zzattr_attrReadGlobalVariables_cache;
    /** */
    public com.google.common.collect.ImmutableList<VarDef> attrReadGlobalVariables() {
        if (zzattr_attrReadGlobalVariables_state == 0) {
            zzattr_attrReadGlobalVariables_state = 1;
            zzattr_attrReadGlobalVariables_cache = de.peeeq.wurstscript.utils.Utils.emptyList();
            while (true) {
                com.google.common.collect.ImmutableList<VarDef> r = de.peeeq.wurstscript.attributes.UsedGlobalVariables.getReadGlobals((StmtLoop)this);
                if (zzattr_attrReadGlobalVariables_state == 3) {
                    if (!zzattr_attrReadGlobalVariables_cache.equals(r)) {
                        zzattr_attrReadGlobalVariables_cache = r;
                        continue;
                    }
                }
                zzattr_attrReadGlobalVariables_cache = r;
                break;
            }
            zzattr_attrReadGlobalVariables_state = 2;
        } else if (zzattr_attrReadGlobalVariables_state == 1) {
            zzattr_attrReadGlobalVariables_state = 3;
        }
        return zzattr_attrReadGlobalVariables_cache;
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((StmtLoop)this);
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((StmtLoop)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((StmtLoop)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((StmtLoop)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((StmtLoop)this, spacer, sb, indent);
    }
}
