//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class StmtReturnImpl implements StmtReturn{
    StmtReturnImpl(de.peeeq.wurstscript.parser.WPos source, OptExpr returnedObj) {
        if (source == null)
            throw new IllegalArgumentException("Element source must not be null.");
        if (returnedObj == null)
            throw new IllegalArgumentException("Element returnedObj must not be null.");
        this.source = source;
        this.returnedObj = returnedObj;
        returnedObj.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.parser.WPos source;
    public void setSource(de.peeeq.wurstscript.parser.WPos source) {
        if (source == null) throw new IllegalArgumentException();
        this.source = source;
    } 
    public de.peeeq.wurstscript.parser.WPos getSource() { return source; }

    private OptExpr returnedObj;
    public void setReturnedObj(OptExpr returnedObj) {
        if (returnedObj == null) throw new IllegalArgumentException();
        this.returnedObj.setParent(null);
        returnedObj.setParent(this);
        this.returnedObj = returnedObj;
    } 
    public OptExpr getReturnedObj() { return returnedObj; }

    public Element get(int i) {
        switch (i) {
            case 0: return returnedObj;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = returnedObj; setReturnedObj((OptExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.returnedObj);
    }
    public int size() {
        return 1;
    }
    @Override public StmtReturn copy() {
        StmtReturn result = new StmtReturnImpl(source, (OptExpr) this.returnedObj.copy());
        return result;
    }

    @Override public StmtReturn copyWithRefs() {
        StmtReturn res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        returnedObj.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_attrNextStatements_state = 0;
        zzattr_attrPreviousStatements_state = 0;
        zzattr_attrListIndex_state = 0;
        zzattr_attrReadVariables_state = 0;
        zzattr_attrUsedGlobalVariables_state = 0;
        zzattr_attrReadGlobalVariables_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(ControlflowStatement.Matcher<T> matcher) {
        return matcher.case_StmtReturn(this);
    }
    @Override public void match(ControlflowStatement.MatcherVoid matcher) {
        matcher.case_StmtReturn(this);
    }

    @Override public <T> T match(HasReadVariables.Matcher<T> matcher) {
        return matcher.case_StmtReturn(this);
    }
    @Override public void match(HasReadVariables.MatcherVoid matcher) {
        matcher.case_StmtReturn(this);
    }

    @Override public <T> T match(AstElementWithSource.Matcher<T> matcher) {
        return matcher.case_StmtReturn(this);
    }
    @Override public void match(AstElementWithSource.MatcherVoid matcher) {
        matcher.case_StmtReturn(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_StmtReturn(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_StmtReturn(this);
    }

    @Override public <T> T match(WStatement.Matcher<T> matcher) {
        return matcher.case_StmtReturn(this);
    }
    @Override public void match(WStatement.MatcherVoid matcher) {
        matcher.case_StmtReturn(this);
    }

    @Override public <T> T match(ExprOrStatements.Matcher<T> matcher) {
        return matcher.case_StmtReturn(this);
    }
    @Override public void match(ExprOrStatements.MatcherVoid matcher) {
        matcher.case_StmtReturn(this);
    }

    @Override public String toString() {
        return "StmtReturn(" + source + ", " +returnedObj+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof StmtReturn) {
            StmtReturn o = (StmtReturn) e;
            return this.returnedObj.structuralEquals(o.getReturnedObj());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_attrNextStatements_state = 0;
    private java.util.List<WStatement> zzattr_attrNextStatements_cache;
    /** "returns all statements which can be executed after this statement"*/
    public java.util.List<WStatement> attrNextStatements() {
        if (zzattr_attrNextStatements_state == 0) {
            try {
                zzattr_attrNextStatements_state = 1;
                zzattr_attrNextStatements_cache = de.peeeq.wurstscript.attributes.Flow.getNext((StmtReturn)this);
            } finally {
                zzattr_attrNextStatements_state = 0;
            }
            zzattr_attrNextStatements_state = 2;
        } else if (zzattr_attrNextStatements_state == 1) {
            throw new CyclicDependencyError(this, "attrNextStatements");
        }
        return zzattr_attrNextStatements_cache;
    }
// circular = null
    private int zzattr_attrPreviousStatements_state = 0;
    private java.util.List<WStatement> zzattr_attrPreviousStatements_cache;
    /** "returns all statements which could have been executed before this statement"*/
    public java.util.List<WStatement> attrPreviousStatements() {
        if (zzattr_attrPreviousStatements_state == 0) {
            try {
                zzattr_attrPreviousStatements_state = 1;
                zzattr_attrPreviousStatements_cache = de.peeeq.wurstscript.attributes.Flow.getPrevious((StmtReturn)this);
            } finally {
                zzattr_attrPreviousStatements_state = 0;
            }
            zzattr_attrPreviousStatements_state = 2;
        } else if (zzattr_attrPreviousStatements_state == 1) {
            throw new CyclicDependencyError(this, "attrPreviousStatements");
        }
        return zzattr_attrPreviousStatements_cache;
    }
// circular = null
    private int zzattr_attrListIndex_state = 0;
    private int zzattr_attrListIndex_cache;
    /** "returns the index this statement has in the underlying list"*/
    public int attrListIndex() {
        if (zzattr_attrListIndex_state == 0) {
            try {
                zzattr_attrListIndex_state = 1;
                zzattr_attrListIndex_cache = de.peeeq.wurstscript.attributes.Flow.getListIndex((StmtReturn)this);
            } finally {
                zzattr_attrListIndex_state = 0;
            }
            zzattr_attrListIndex_state = 2;
        } else if (zzattr_attrListIndex_state == 1) {
            throw new CyclicDependencyError(this, "attrListIndex");
        }
        return zzattr_attrListIndex_cache;
    }
// circular = null
    private int zzattr_attrReadVariables_state = 0;
    private de.peeeq.immutablecollections.ImmutableList<NameDef> zzattr_attrReadVariables_cache;
    /** */
    public de.peeeq.immutablecollections.ImmutableList<NameDef> attrReadVariables() {
        if (zzattr_attrReadVariables_state == 0) {
            try {
                zzattr_attrReadVariables_state = 1;
                zzattr_attrReadVariables_cache = de.peeeq.wurstscript.attributes.ReadVariables.calculate((StmtReturn)this);
            } finally {
                zzattr_attrReadVariables_state = 0;
            }
            zzattr_attrReadVariables_state = 2;
        } else if (zzattr_attrReadVariables_state == 1) {
            throw new CyclicDependencyError(this, "attrReadVariables");
        }
        return zzattr_attrReadVariables_cache;
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((StmtReturn)this);
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((StmtReturn)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((StmtReturn)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((StmtReturn)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((StmtReturn)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((StmtReturn)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((StmtReturn)this);
    }
    /** */
    public de.peeeq.wurstscript.jassIm.ImStmt imTranslateStmt(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.StmtTranslation.translate((StmtReturn)this, translator, f);
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((StmtReturn)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((StmtReturn)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((StmtReturn)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((StmtReturn)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((StmtReturn)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((StmtReturn)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((StmtReturn)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((StmtReturn)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((StmtReturn)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((StmtReturn)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((StmtReturn)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((StmtReturn)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((StmtReturn)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((StmtReturn)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((StmtReturn)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((StmtReturn)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((StmtReturn)this, receiverType, name);
    }
// circular = de.peeeq.wurstscript.utils.Utils.emptyList
    private int zzattr_attrUsedGlobalVariables_state = 0;
    private com.google.common.collect.ImmutableList<VarDef> zzattr_attrUsedGlobalVariables_cache;
    /** */
    public com.google.common.collect.ImmutableList<VarDef> attrUsedGlobalVariables() {
        if (zzattr_attrUsedGlobalVariables_state == 0) {
            zzattr_attrUsedGlobalVariables_state = 1;
            zzattr_attrUsedGlobalVariables_cache = de.peeeq.wurstscript.utils.Utils.emptyList();
            while (true) {
                com.google.common.collect.ImmutableList<VarDef> r = de.peeeq.wurstscript.attributes.UsedGlobalVariables.getUsedGlobals((StmtReturn)this);
                if (zzattr_attrUsedGlobalVariables_state == 3) {
                    if (!zzattr_attrUsedGlobalVariables_cache.equals(r)) {
                        zzattr_attrUsedGlobalVariables_cache = r;
                        continue;
                    }
                }
                zzattr_attrUsedGlobalVariables_cache = r;
                break;
            }
            zzattr_attrUsedGlobalVariables_state = 2;
        } else if (zzattr_attrUsedGlobalVariables_state == 1) {
            zzattr_attrUsedGlobalVariables_state = 3;
        }
        return zzattr_attrUsedGlobalVariables_cache;
    }
// circular = de.peeeq.wurstscript.utils.Utils.emptyList
    private int zzattr_attrReadGlobalVariables_state = 0;
    private com.google.common.collect.ImmutableList<VarDef> zzattr_attrReadGlobalVariables_cache;
    /** */
    public com.google.common.collect.ImmutableList<VarDef> attrReadGlobalVariables() {
        if (zzattr_attrReadGlobalVariables_state == 0) {
            zzattr_attrReadGlobalVariables_state = 1;
            zzattr_attrReadGlobalVariables_cache = de.peeeq.wurstscript.utils.Utils.emptyList();
            while (true) {
                com.google.common.collect.ImmutableList<VarDef> r = de.peeeq.wurstscript.attributes.UsedGlobalVariables.getReadGlobals((StmtReturn)this);
                if (zzattr_attrReadGlobalVariables_state == 3) {
                    if (!zzattr_attrReadGlobalVariables_cache.equals(r)) {
                        zzattr_attrReadGlobalVariables_cache = r;
                        continue;
                    }
                }
                zzattr_attrReadGlobalVariables_cache = r;
                break;
            }
            zzattr_attrReadGlobalVariables_state = 2;
        } else if (zzattr_attrReadGlobalVariables_state == 1) {
            zzattr_attrReadGlobalVariables_state = 3;
        }
        return zzattr_attrReadGlobalVariables_cache;
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((StmtReturn)this);
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((StmtReturn)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((StmtReturn)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((StmtReturn)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((StmtReturn)this, spacer, sb, indent);
    }
}
