//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class TypeExprArrayImpl implements TypeExprArray{
    TypeExprArrayImpl(de.peeeq.wurstscript.parser.WPos source, TypeExpr base, OptExpr arraySize) {
        if (source == null)
            throw new IllegalArgumentException("Element source must not be null.");
        if (base == null)
            throw new IllegalArgumentException("Element base must not be null.");
        if (arraySize == null)
            throw new IllegalArgumentException("Element arraySize must not be null.");
        this.source = source;
        this.base = base;
        this.arraySize = arraySize;
        base.setParent(this);
        arraySize.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.parser.WPos source;
    public void setSource(de.peeeq.wurstscript.parser.WPos source) {
        if (source == null) throw new IllegalArgumentException();
        this.source = source;
    } 
    public de.peeeq.wurstscript.parser.WPos getSource() { return source; }

    private TypeExpr base;
    public void setBase(TypeExpr base) {
        if (base == null) throw new IllegalArgumentException();
        this.base.setParent(null);
        base.setParent(this);
        this.base = base;
    } 
    public TypeExpr getBase() { return base; }

    private OptExpr arraySize;
    public void setArraySize(OptExpr arraySize) {
        if (arraySize == null) throw new IllegalArgumentException();
        this.arraySize.setParent(null);
        arraySize.setParent(this);
        this.arraySize = arraySize;
    } 
    public OptExpr getArraySize() { return arraySize; }

    public Element get(int i) {
        switch (i) {
            case 0: return base;
            case 1: return arraySize;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = base; setBase((TypeExpr) newElem); return oldElem;
            case 1: oldElem = arraySize; setArraySize((OptExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.base);
        action.accept(this.arraySize);
    }
    public int size() {
        return 2;
    }
    @Override public TypeExprArray copy() {
        TypeExprArray result = new TypeExprArrayImpl(source, (TypeExpr) this.base.copy(), (OptExpr) this.arraySize.copy());
        return result;
    }

    @Override public TypeExprArray copyWithRefs() {
        TypeExprArray res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        base.clearAttributes();
        arraySize.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_attrTyp_state = 0;
        zzattr_attrTypRaw_state = 0;
        zzattr_attrTypeDef_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(TypeRef.Matcher<T> matcher) {
        return matcher.case_TypeExprArray(this);
    }
    @Override public void match(TypeRef.MatcherVoid matcher) {
        matcher.case_TypeExprArray(this);
    }

    @Override public <T> T match(AstElementWithSource.Matcher<T> matcher) {
        return matcher.case_TypeExprArray(this);
    }
    @Override public void match(AstElementWithSource.MatcherVoid matcher) {
        matcher.case_TypeExprArray(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_TypeExprArray(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_TypeExprArray(this);
    }

    @Override public <T> T match(TypeExpr.Matcher<T> matcher) {
        return matcher.case_TypeExprArray(this);
    }
    @Override public void match(TypeExpr.MatcherVoid matcher) {
        matcher.case_TypeExprArray(this);
    }

    @Override public <T> T match(OptTypeExpr.Matcher<T> matcher) {
        return matcher.case_TypeExprArray(this);
    }
    @Override public void match(OptTypeExpr.MatcherVoid matcher) {
        matcher.case_TypeExprArray(this);
    }

    @Override public String toString() {
        return "TypeExprArray(" + source + ", " +base + ", " +arraySize+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof TypeExprArray) {
            TypeExprArray o = (TypeExprArray) e;
            return this.base.structuralEquals(o.getBase())
                && this.arraySize.structuralEquals(o.getArraySize());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_attrTyp_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrTyp_cache;
    /** */
    public de.peeeq.wurstscript.types.WurstType attrTyp() {
        if (zzattr_attrTyp_state == 0) {
            try {
                zzattr_attrTyp_state = 1;
                zzattr_attrTyp_cache = de.peeeq.wurstscript.attributes.AttrTypeExprType.normalizedType((TypeExprArray)this);
            } finally {
                zzattr_attrTyp_state = 0;
            }
            zzattr_attrTyp_state = 2;
        } else if (zzattr_attrTyp_state == 1) {
            throw new CyclicDependencyError(this, "attrTyp");
        }
        return zzattr_attrTyp_cache;
    }
// circular = null
    private int zzattr_attrTypRaw_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrTypRaw_cache;
    /** */
    public de.peeeq.wurstscript.types.WurstType attrTypRaw() {
        if (zzattr_attrTypRaw_state == 0) {
            try {
                zzattr_attrTypRaw_state = 1;
                zzattr_attrTypRaw_cache = de.peeeq.wurstscript.attributes.AttrTypeExprType.calculate((TypeExprArray)this);
            } finally {
                zzattr_attrTypRaw_state = 0;
            }
            zzattr_attrTypRaw_state = 2;
        } else if (zzattr_attrTypRaw_state == 1) {
            throw new CyclicDependencyError(this, "attrTypRaw");
        }
        return zzattr_attrTypRaw_cache;
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((TypeExprArray)this);
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((TypeExprArray)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((TypeExprArray)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((TypeExprArray)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((TypeExprArray)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((TypeExprArray)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((TypeExprArray)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((TypeExprArray)this);
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((TypeExprArray)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((TypeExprArray)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((TypeExprArray)this);
    }
// circular = null
    private int zzattr_attrTypeDef_state = 0;
    private @org.eclipse.jdt.annotation.Nullable TypeDef zzattr_attrTypeDef_cache;
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef attrTypeDef() {
        if (zzattr_attrTypeDef_state == 0) {
            try {
                zzattr_attrTypeDef_state = 1;
                zzattr_attrTypeDef_cache = de.peeeq.wurstscript.attributes.AttrTypeDef.calculate((TypeExprArray)this);
            } finally {
                zzattr_attrTypeDef_state = 0;
            }
            zzattr_attrTypeDef_state = 2;
        } else if (zzattr_attrTypeDef_state == 1) {
            throw new CyclicDependencyError(this, "attrTypeDef");
        }
        return zzattr_attrTypeDef_cache;
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((TypeExprArray)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((TypeExprArray)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((TypeExprArray)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((TypeExprArray)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((TypeExprArray)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((TypeExprArray)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((TypeExprArray)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((TypeExprArray)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((TypeExprArray)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((TypeExprArray)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((TypeExprArray)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((TypeExprArray)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((TypeExprArray)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((TypeExprArray)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((TypeExprArray)this);
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((TypeExprArray)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((TypeExprArray)this);
    }
    /** */
    public boolean isModuleUseTypeArg() {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isModuleUseTypeArg((TypeExprArray)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((TypeExprArray)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((TypeExprArray)this, spacer, sb, indent);
    }
}
