//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class WPackageImpl implements WPackage{
    WPackageImpl(de.peeeq.wurstscript.parser.WPos source, Modifiers modifiers, Identifier nameId, WImports imports, WEntities elements) {
        if (source == null)
            throw new IllegalArgumentException("Element source must not be null.");
        if (modifiers == null)
            throw new IllegalArgumentException("Element modifiers must not be null.");
        if (nameId == null)
            throw new IllegalArgumentException("Element nameId must not be null.");
        if (imports == null)
            throw new IllegalArgumentException("Element imports must not be null.");
        if (elements == null)
            throw new IllegalArgumentException("Element elements must not be null.");
        this.source = source;
        this.modifiers = modifiers;
        this.nameId = nameId;
        this.imports = imports;
        this.elements = elements;
        modifiers.setParent(this);
        nameId.setParent(this);
        imports.setParent(this);
        elements.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.parser.WPos source;
    public void setSource(de.peeeq.wurstscript.parser.WPos source) {
        if (source == null) throw new IllegalArgumentException();
        this.source = source;
    } 
    public de.peeeq.wurstscript.parser.WPos getSource() { return source; }

    private Modifiers modifiers;
    public void setModifiers(Modifiers modifiers) {
        if (modifiers == null) throw new IllegalArgumentException();
        this.modifiers.setParent(null);
        modifiers.setParent(this);
        this.modifiers = modifiers;
    } 
    public Modifiers getModifiers() { return modifiers; }

    private Identifier nameId;
    public void setNameId(Identifier nameId) {
        if (nameId == null) throw new IllegalArgumentException();
        this.nameId.setParent(null);
        nameId.setParent(this);
        this.nameId = nameId;
    } 
    public Identifier getNameId() { return nameId; }

    private WImports imports;
    public void setImports(WImports imports) {
        if (imports == null) throw new IllegalArgumentException();
        this.imports.setParent(null);
        imports.setParent(this);
        this.imports = imports;
    } 
    public WImports getImports() { return imports; }

    private WEntities elements;
    public void setElements(WEntities elements) {
        if (elements == null) throw new IllegalArgumentException();
        this.elements.setParent(null);
        elements.setParent(this);
        this.elements = elements;
    } 
    public WEntities getElements() { return elements; }

    public Element get(int i) {
        switch (i) {
            case 0: return modifiers;
            case 1: return nameId;
            case 2: return imports;
            case 3: return elements;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = modifiers; setModifiers((Modifiers) newElem); return oldElem;
            case 1: oldElem = nameId; setNameId((Identifier) newElem); return oldElem;
            case 2: oldElem = imports; setImports((WImports) newElem); return oldElem;
            case 3: oldElem = elements; setElements((WEntities) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.modifiers);
        action.accept(this.nameId);
        action.accept(this.imports);
        action.accept(this.elements);
    }
    public int size() {
        return 4;
    }
    @Override public WPackage copy() {
        WPackage result = new WPackageImpl(source, (Modifiers) this.modifiers.copy(), (Identifier) this.nameId.copy(), (WImports) this.imports.copy(), (WEntities) this.elements.copy());
        return result;
    }

    @Override public WPackage copyWithRefs() {
        WPackage res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        modifiers.clearAttributes();
        nameId.clearAttributes();
        imports.clearAttributes();
        elements.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_attrReadVariables_state = 0;
        zzattr_attrTyp_state = 0;
        zzattr_attrNextScope_state = 0;
        zzattr_attrConfigActualNameDef_state = 0;
        zzattr_attrNameLinks_state = 0;
        zzattr_attrTypeNameLinks_state = 0;
        zzattr_attrExportedNameLinks_state = 0;
        zzattr_attrExportedTypeNameLinks_state = 0;
        zzattr_attrImportedPackagesTransitive_state = 0;
        zzattr_attrInitDependencies_state = 0;
        zzattr_attrInitDependenciesTransitive_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(HasModifier.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(HasModifier.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(HasReadVariables.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(HasReadVariables.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(Documentable.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(Documentable.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(NamedScope.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(NamedScope.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(WScope.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(WScope.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(PackageOrGlobal.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(PackageOrGlobal.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(TopLevelDeclaration.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(TopLevelDeclaration.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(NameDef.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(NameDef.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(AstElementWithSource.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(AstElementWithSource.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public <T> T match(AstElementWithNameId.Matcher<T> matcher) {
        return matcher.case_WPackage(this);
    }
    @Override public void match(AstElementWithNameId.MatcherVoid matcher) {
        matcher.case_WPackage(this);
    }

    @Override public String toString() {
        return "WPackage(" + source + ", " +modifiers + ", " +nameId + ", " +imports + ", " +elements+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof WPackage) {
            WPackage o = (WPackage) e;
            return this.modifiers.structuralEquals(o.getModifiers())
                && this.nameId.structuralEquals(o.getNameId())
                && this.imports.structuralEquals(o.getImports())
                && this.elements.structuralEquals(o.getElements());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_attrReadVariables_state = 0;
    private de.peeeq.immutablecollections.ImmutableList<NameDef> zzattr_attrReadVariables_cache;
    /** */
    public de.peeeq.immutablecollections.ImmutableList<NameDef> attrReadVariables() {
        if (zzattr_attrReadVariables_state == 0) {
            try {
                zzattr_attrReadVariables_state = 1;
                zzattr_attrReadVariables_cache = de.peeeq.wurstscript.attributes.ReadVariables.calculate((WPackage)this);
            } finally {
                zzattr_attrReadVariables_state = 0;
            }
            zzattr_attrReadVariables_state = 2;
        } else if (zzattr_attrReadVariables_state == 1) {
            throw new CyclicDependencyError(this, "attrReadVariables");
        }
        return zzattr_attrReadVariables_cache;
    }
// circular = null
    private int zzattr_attrTyp_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrTyp_cache;
    /** */
    public de.peeeq.wurstscript.types.WurstType attrTyp() {
        if (zzattr_attrTyp_state == 0) {
            try {
                zzattr_attrTyp_state = 1;
                zzattr_attrTyp_cache = de.peeeq.wurstscript.attributes.AttrVarDefType.calculate((WPackage)this);
            } finally {
                zzattr_attrTyp_state = 0;
            }
            zzattr_attrTyp_state = 2;
        } else if (zzattr_attrTyp_state == 1) {
            throw new CyclicDependencyError(this, "attrTyp");
        }
        return zzattr_attrTyp_cache;
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((WPackage)this);
    }
// circular = null
    private int zzattr_attrNextScope_state = 0;
    private @org.eclipse.jdt.annotation.Nullable WScope zzattr_attrNextScope_cache;
    /** "returns the scope surrounding this scope"*/
    public @org.eclipse.jdt.annotation.Nullable WScope attrNextScope() {
        if (zzattr_attrNextScope_state == 0) {
            try {
                zzattr_attrNextScope_state = 1;
                zzattr_attrNextScope_cache = de.peeeq.wurstscript.attributes.AttrNearest.nextScope((WPackage)this);
            } finally {
                zzattr_attrNextScope_state = 0;
            }
            zzattr_attrNextScope_state = 2;
        } else if (zzattr_attrNextScope_state == 1) {
            throw new CyclicDependencyError(this, "attrNextScope");
        }
        return zzattr_attrNextScope_cache;
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((WPackage)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((WPackage)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((WPackage)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((WPackage)this);
    }
    /** */
    public boolean attrIsCompiletime() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isCompiletime((WPackage)this);
    }
    /** */
    public boolean attrHasAnnotation(String name) {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.hasAnnotation((WPackage)this, name);
    }
    /** */
    public Annotation attrGetAnnotation(String name) {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.getAnnotation((WPackage)this, name);
    }
    /** */
    public boolean attrIsPublic() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isPublic((WPackage)this);
    }
    /** */
    public boolean attrIsPublicRead() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isPublicRead((WPackage)this);
    }
    /** */
    public boolean attrIsPrivate() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isPrivate((WPackage)this);
    }
    /** */
    public boolean attrIsProtected() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isProtected((WPackage)this);
    }
    /** */
    public boolean attrIsStatic() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isStatic((WPackage)this);
    }
    /** */
    public boolean attrIsOverride() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isOverride((WPackage)this);
    }
    /** */
    public boolean attrIsAbstract() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isAbstract((WPackage)this);
    }
    /** */
    public boolean attrIsConstant() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isConstant((WPackage)this);
    }
    /** */
    public boolean attrIsVararg() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isVararg((WPackage)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((WPackage)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((WPackage)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((WPackage)this);
    }
// circular = null
    private int zzattr_attrConfigActualNameDef_state = 0;
    private NameDef zzattr_attrConfigActualNameDef_cache;
    /** */
    public NameDef attrConfigActualNameDef() {
        if (zzattr_attrConfigActualNameDef_state == 0) {
            try {
                zzattr_attrConfigActualNameDef_state = 1;
                zzattr_attrConfigActualNameDef_cache = de.peeeq.wurstscript.attributes.CofigActualDef.calculate((WPackage)this);
            } finally {
                zzattr_attrConfigActualNameDef_state = 0;
            }
            zzattr_attrConfigActualNameDef_state = 2;
        } else if (zzattr_attrConfigActualNameDef_state == 1) {
            throw new CyclicDependencyError(this, "attrConfigActualNameDef");
        }
        return zzattr_attrConfigActualNameDef_cache;
    }
    /** */
    public boolean hasAnnotation(String annotation) {
        return de.peeeq.wurstscript.attributes.HasAnnotation.hasAnnotation((WPackage)this, annotation);
    }
    /** */
    public Annotation getAnnotation(String annotation) {
        return de.peeeq.wurstscript.attributes.HasAnnotation.getAnnotation((WPackage)this, annotation);
    }
    /** */
    public void imTranslateTLD(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator) {
        de.peeeq.wurstscript.translation.imtranslation.TLDTranslation.translate((WPackage)this, translator);
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((WPackage)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((WPackage)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((WPackage)this);
    }
// circular = null
    private int zzattr_attrNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> zzattr_attrNameLinks_cache;
    /** "returns a map of all the names visible in this scope."*/
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> attrNameLinks() {
        if (zzattr_attrNameLinks_state == 0) {
            try {
                zzattr_attrNameLinks_state = 1;
                zzattr_attrNameLinks_cache = de.peeeq.wurstscript.attributes.names.NameLinks.calculate((WPackage)this);
            } finally {
                zzattr_attrNameLinks_state = 0;
            }
            zzattr_attrNameLinks_state = 2;
        } else if (zzattr_attrNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrNameLinks");
        }
        return zzattr_attrNameLinks_cache;
    }
// circular = null
    private int zzattr_attrTypeNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> zzattr_attrTypeNameLinks_cache;
    /** "returns a map of all the names visible in this scope."*/
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> attrTypeNameLinks() {
        if (zzattr_attrTypeNameLinks_state == 0) {
            try {
                zzattr_attrTypeNameLinks_state = 1;
                zzattr_attrTypeNameLinks_cache = de.peeeq.wurstscript.attributes.names.TypeNameLinks.calculate((WPackage)this);
            } finally {
                zzattr_attrTypeNameLinks_state = 0;
            }
            zzattr_attrTypeNameLinks_state = 2;
        } else if (zzattr_attrTypeNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrTypeNameLinks");
        }
        return zzattr_attrTypeNameLinks_cache;
    }
// circular = null
    private int zzattr_attrExportedNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> zzattr_attrExportedNameLinks_cache;
    /** */
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.DefLink> attrExportedNameLinks() {
        if (zzattr_attrExportedNameLinks_state == 0) {
            try {
                zzattr_attrExportedNameLinks_state = 1;
                zzattr_attrExportedNameLinks_cache = de.peeeq.wurstscript.attributes.names.Exports.exportedNameLinks((WPackage)this);
            } finally {
                zzattr_attrExportedNameLinks_state = 0;
            }
            zzattr_attrExportedNameLinks_state = 2;
        } else if (zzattr_attrExportedNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrExportedNameLinks");
        }
        return zzattr_attrExportedNameLinks_cache;
    }
// circular = null
    private int zzattr_attrExportedTypeNameLinks_state = 0;
    private com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> zzattr_attrExportedTypeNameLinks_cache;
    /** */
    public com.google.common.collect.ImmutableMultimap<String, de.peeeq.wurstscript.attributes.names.TypeLink> attrExportedTypeNameLinks() {
        if (zzattr_attrExportedTypeNameLinks_state == 0) {
            try {
                zzattr_attrExportedTypeNameLinks_state = 1;
                zzattr_attrExportedTypeNameLinks_cache = de.peeeq.wurstscript.attributes.names.Exports.exportedTypeNameLinks((WPackage)this);
            } finally {
                zzattr_attrExportedTypeNameLinks_state = 0;
            }
            zzattr_attrExportedTypeNameLinks_state = 2;
        } else if (zzattr_attrExportedTypeNameLinks_state == 1) {
            throw new CyclicDependencyError(this, "attrExportedTypeNameLinks");
        }
        return zzattr_attrExportedTypeNameLinks_cache;
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((WPackage)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((WPackage)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((WPackage)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((WPackage)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((WPackage)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((WPackage)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((WPackage)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((WPackage)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((WPackage)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((WPackage)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((WPackage)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((WPackage)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((WPackage)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((WPackage)this, receiverType, name);
    }
    /** */
    public String attrComment() {
        return de.peeeq.wurstscript.attributes.AttrWurstDoc.getComment((WPackage)this);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((WPackage)this);
    }
// circular = null
    private int zzattr_attrImportedPackagesTransitive_state = 0;
    private com.google.common.collect.ImmutableCollection<WPackage> zzattr_attrImportedPackagesTransitive_cache;
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrImportedPackagesTransitive() {
        if (zzattr_attrImportedPackagesTransitive_state == 0) {
            try {
                zzattr_attrImportedPackagesTransitive_state = 1;
                zzattr_attrImportedPackagesTransitive_cache = de.peeeq.wurstscript.attributes.InitOrder.importedPackagesTrans((WPackage)this);
            } finally {
                zzattr_attrImportedPackagesTransitive_state = 0;
            }
            zzattr_attrImportedPackagesTransitive_state = 2;
        } else if (zzattr_attrImportedPackagesTransitive_state == 1) {
            throw new CyclicDependencyError(this, "attrImportedPackagesTransitive");
        }
        return zzattr_attrImportedPackagesTransitive_cache;
    }
// circular = null
    private int zzattr_attrInitDependencies_state = 0;
    private com.google.common.collect.ImmutableList<WPackage> zzattr_attrInitDependencies_cache;
    /** */
    public com.google.common.collect.ImmutableList<WPackage> attrInitDependencies() {
        if (zzattr_attrInitDependencies_state == 0) {
            try {
                zzattr_attrInitDependencies_state = 1;
                zzattr_attrInitDependencies_cache = de.peeeq.wurstscript.attributes.InitOrder.initDependencies((WPackage)this);
            } finally {
                zzattr_attrInitDependencies_state = 0;
            }
            zzattr_attrInitDependencies_state = 2;
        } else if (zzattr_attrInitDependencies_state == 1) {
            throw new CyclicDependencyError(this, "attrInitDependencies");
        }
        return zzattr_attrInitDependencies_cache;
    }
// circular = null
    private int zzattr_attrInitDependenciesTransitive_state = 0;
    private com.google.common.collect.ImmutableList<WPackage> zzattr_attrInitDependenciesTransitive_cache;
    /** */
    public com.google.common.collect.ImmutableList<WPackage> attrInitDependenciesTransitive() {
        if (zzattr_attrInitDependenciesTransitive_state == 0) {
            try {
                zzattr_attrInitDependenciesTransitive_state = 1;
                zzattr_attrInitDependenciesTransitive_cache = de.peeeq.wurstscript.attributes.InitOrder.initDependenciesTransitive((WPackage)this);
            } finally {
                zzattr_attrInitDependenciesTransitive_state = 0;
            }
            zzattr_attrInitDependenciesTransitive_state = 2;
        } else if (zzattr_attrInitDependenciesTransitive_state == 1) {
            throw new CyclicDependencyError(this, "attrInitDependenciesTransitive");
        }
        return zzattr_attrInitDependenciesTransitive_cache;
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((WPackage)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((WPackage)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((WPackage)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((WPackage)this, spacer, sb, indent);
    }
    /** */
    public String getName() {
        return de.peeeq.wurstscript.attributes.SmallHelpers.getName((WPackage)this);
    }
}
