//generated by abstract-syntax-gen
package de.peeeq.wurstscript.ast;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class WParameterImpl implements WParameter{
    WParameterImpl(de.peeeq.wurstscript.parser.WPos source, Modifiers modifiers, TypeExpr typ, Identifier nameId) {
        if (source == null)
            throw new IllegalArgumentException("Element source must not be null.");
        if (modifiers == null)
            throw new IllegalArgumentException("Element modifiers must not be null.");
        if (typ == null)
            throw new IllegalArgumentException("Element typ must not be null.");
        if (nameId == null)
            throw new IllegalArgumentException("Element nameId must not be null.");
        this.source = source;
        this.modifiers = modifiers;
        this.typ = typ;
        this.nameId = nameId;
        modifiers.setParent(this);
        typ.setParent(this);
        nameId.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.parser.WPos source;
    public void setSource(de.peeeq.wurstscript.parser.WPos source) {
        if (source == null) throw new IllegalArgumentException();
        this.source = source;
    } 
    public de.peeeq.wurstscript.parser.WPos getSource() { return source; }

    private Modifiers modifiers;
    public void setModifiers(Modifiers modifiers) {
        if (modifiers == null) throw new IllegalArgumentException();
        this.modifiers.setParent(null);
        modifiers.setParent(this);
        this.modifiers = modifiers;
    } 
    public Modifiers getModifiers() { return modifiers; }

    private TypeExpr typ;
    public void setTyp(TypeExpr typ) {
        if (typ == null) throw new IllegalArgumentException();
        this.typ.setParent(null);
        typ.setParent(this);
        this.typ = typ;
    } 
    public TypeExpr getTyp() { return typ; }

    private Identifier nameId;
    public void setNameId(Identifier nameId) {
        if (nameId == null) throw new IllegalArgumentException();
        this.nameId.setParent(null);
        nameId.setParent(this);
        this.nameId = nameId;
    } 
    public Identifier getNameId() { return nameId; }

    public Element get(int i) {
        switch (i) {
            case 0: return modifiers;
            case 1: return typ;
            case 2: return nameId;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = modifiers; setModifiers((Modifiers) newElem); return oldElem;
            case 1: oldElem = typ; setTyp((TypeExpr) newElem); return oldElem;
            case 2: oldElem = nameId; setNameId((Identifier) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.modifiers);
        action.accept(this.typ);
        action.accept(this.nameId);
    }
    public int size() {
        return 3;
    }
    @Override public WParameter copy() {
        WParameter result = new WParameterImpl(source, (Modifiers) this.modifiers.copy(), (TypeExpr) this.typ.copy(), (Identifier) this.nameId.copy());
        return result;
    }

    @Override public WParameter copyWithRefs() {
        WParameter res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        modifiers.clearAttributes();
        typ.clearAttributes();
        nameId.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_attrTyp_state = 0;
        zzattr_attrConfigActualNameDef_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(VarDef.Matcher<T> matcher) {
        return matcher.case_WParameter(this);
    }
    @Override public void match(VarDef.MatcherVoid matcher) {
        matcher.case_WParameter(this);
    }

    @Override public <T> T match(HasModifier.Matcher<T> matcher) {
        return matcher.case_WParameter(this);
    }
    @Override public void match(HasModifier.MatcherVoid matcher) {
        matcher.case_WParameter(this);
    }

    @Override public <T> T match(Documentable.Matcher<T> matcher) {
        return matcher.case_WParameter(this);
    }
    @Override public void match(Documentable.MatcherVoid matcher) {
        matcher.case_WParameter(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_WParameter(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_WParameter(this);
    }

    @Override public <T> T match(NameDef.Matcher<T> matcher) {
        return matcher.case_WParameter(this);
    }
    @Override public void match(NameDef.MatcherVoid matcher) {
        matcher.case_WParameter(this);
    }

    @Override public <T> T match(AstElementWithSource.Matcher<T> matcher) {
        return matcher.case_WParameter(this);
    }
    @Override public void match(AstElementWithSource.MatcherVoid matcher) {
        matcher.case_WParameter(this);
    }

    @Override public <T> T match(AstElementWithNameId.Matcher<T> matcher) {
        return matcher.case_WParameter(this);
    }
    @Override public void match(AstElementWithNameId.MatcherVoid matcher) {
        matcher.case_WParameter(this);
    }

    @Override public String toString() {
        return "WParameter(" + source + ", " +modifiers + ", " +typ + ", " +nameId+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof WParameter) {
            WParameter o = (WParameter) e;
            return this.modifiers.structuralEquals(o.getModifiers())
                && this.typ.structuralEquals(o.getTyp())
                && this.nameId.structuralEquals(o.getNameId());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_attrTyp_state = 0;
    private de.peeeq.wurstscript.types.WurstType zzattr_attrTyp_cache;
    /** */
    public de.peeeq.wurstscript.types.WurstType attrTyp() {
        if (zzattr_attrTyp_state == 0) {
            try {
                zzattr_attrTyp_state = 1;
                zzattr_attrTyp_cache = de.peeeq.wurstscript.attributes.AttrVarDefType.calculate((WParameter)this);
            } finally {
                zzattr_attrTyp_state = 0;
            }
            zzattr_attrTyp_state = 2;
        } else if (zzattr_attrTyp_state == 1) {
            throw new CyclicDependencyError(this, "attrTyp");
        }
        return zzattr_attrTyp_cache;
    }
    /** */
    public boolean attrIsDynamicClassMember() {
        return de.peeeq.wurstscript.attributes.AttrIsClassMember.calculate((WParameter)this);
    }
    /** */
    public boolean attrIsDynamicContext() {
        return de.peeeq.wurstscript.attributes.IsDynamicContext.calculate((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable PackageOrGlobal attrNearestPackage() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestPackage((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable NamedScope attrNearestNamedScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestNamedScope((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable WScope attrNearestScope() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestScope((WParameter)this);
    }
    /** */
    public String attrPathDescription() {
        return de.peeeq.wurstscript.attributes.PathDescription.get((WParameter)this);
    }
    /** */
    public CompilationUnit attrCompilationUnit() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestCompilationUnit((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassDef attrNearestClassDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassDef((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrInterface attrNearestClassOrInterface() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrInterface((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ClassOrModule attrNearestClassOrModule() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestClassOrModule((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable StructureDef attrNearestStructureDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestStructureDef((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable FunctionImplementation attrNearestFuncDef() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestFuncDef((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprClosure attrNearestExprClosure() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprClosure((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable ExprStatementsBlock attrNearestExprStatementsBlock() {
        return de.peeeq.wurstscript.attributes.AttrNearest.nearestExprStatementsBlock((WParameter)this);
    }
    /** "returns the element itself if it is a NameDef or returns the referenced NameDef if the elem is a reference or returns null otherwise "*/
    public @org.eclipse.jdt.annotation.Nullable NameDef tryGetNameDef() {
        return de.peeeq.wurstscript.attributes.AttrNameDef.tryGetNameDef((WParameter)this);
    }
    /** */
    public boolean attrIsCompiletime() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isCompiletime((WParameter)this);
    }
    /** */
    public boolean attrHasAnnotation(String name) {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.hasAnnotation((WParameter)this, name);
    }
    /** */
    public Annotation attrGetAnnotation(String name) {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.getAnnotation((WParameter)this, name);
    }
    /** */
    public boolean attrIsPublic() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isPublic((WParameter)this);
    }
    /** */
    public boolean attrIsPublicRead() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isPublicRead((WParameter)this);
    }
    /** */
    public boolean attrIsPrivate() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isPrivate((WParameter)this);
    }
    /** */
    public boolean attrIsProtected() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isProtected((WParameter)this);
    }
    /** */
    public boolean attrIsStatic() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isStatic((WParameter)this);
    }
    /** */
    public boolean attrIsOverride() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isOverride((WParameter)this);
    }
    /** */
    public boolean attrIsAbstract() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isAbstract((WParameter)this);
    }
    /** */
    public boolean attrIsConstant() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isConstant((WParameter)this);
    }
    /** */
    public boolean attrIsVararg() {
        return de.peeeq.wurstscript.attributes.ModifiersHelper.isVararg((WParameter)this);
    }
    /** */
    public de.peeeq.wurstscript.parser.WPos attrSource() {
        return de.peeeq.wurstscript.attributes.AttrPos.getPos((WParameter)this);
    }
    /** "returns the position where errors are marked"*/
    public de.peeeq.wurstscript.parser.WPos attrErrorPos() {
        return de.peeeq.wurstscript.attributes.AttrPos.getErrorPos((WParameter)this);
    }
    /** */
    public WurstModel getModel() {
        return de.peeeq.wurstscript.attributes.AttrImportedPackage.getModel((WParameter)this);
    }
// circular = null
    private int zzattr_attrConfigActualNameDef_state = 0;
    private NameDef zzattr_attrConfigActualNameDef_cache;
    /** */
    public NameDef attrConfigActualNameDef() {
        if (zzattr_attrConfigActualNameDef_state == 0) {
            try {
                zzattr_attrConfigActualNameDef_state = 1;
                zzattr_attrConfigActualNameDef_cache = de.peeeq.wurstscript.attributes.CofigActualDef.calculate((WParameter)this);
            } finally {
                zzattr_attrConfigActualNameDef_state = 0;
            }
            zzattr_attrConfigActualNameDef_state = 2;
        } else if (zzattr_attrConfigActualNameDef_state == 1) {
            throw new CyclicDependencyError(this, "attrConfigActualNameDef");
        }
        return zzattr_attrConfigActualNameDef_cache;
    }
    /** */
    public boolean hasAnnotation(String annotation) {
        return de.peeeq.wurstscript.attributes.HasAnnotation.hasAnnotation((WParameter)this, annotation);
    }
    /** */
    public Annotation getAnnotation(String annotation) {
        return de.peeeq.wurstscript.attributes.HasAnnotation.getAnnotation((WParameter)this, annotation);
    }
    /** */
    public void addError(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addError((WParameter)this, msg);
    }
    /** */
    public void addWarning(String msg) {
        de.peeeq.wurstscript.attributes.ErrorHandling.addWarning((WParameter)this, msg);
    }
    /** */
    public de.peeeq.wurstscript.attributes.ErrorHandler getErrorHandler() {
        return de.peeeq.wurstscript.attributes.ErrorHandling.getErrorHandler((WParameter)this);
    }
    /** "returns a VarLink pointing to this NameDef"*/
    public de.peeeq.wurstscript.attributes.names.VarLink createVarLink(WScope definedIn) {
        return de.peeeq.wurstscript.attributes.names.VarLink.create((WParameter)this, definedIn);
    }
    /** */
    public OptTypeExpr attrOptTypeExpr() {
        return de.peeeq.wurstscript.attributes.names.VarLink.getTypeExpr((WParameter)this);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupType((WParameter)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackage((WParameter)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVar((WParameter)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVarNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarNoConfig((WParameter)this, name, showErrors);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVar((WParameter)this, receiverType, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncs((WParameter)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncsNoConfig(String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsNoConfig((WParameter)this, name, showErrors);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name, boolean showErrors) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncs((WParameter)this, receiverType, name, showErrors);
    }
    /** */
    public @org.eclipse.jdt.annotation.Nullable TypeDef lookupType(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupTypeShort((WParameter)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.PackageLink lookupPackage(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupPackageShort((WParameter)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupVar(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupVarShort((WParameter)this, name);
    }
    /** */
    public de.peeeq.wurstscript.attributes.names.NameLink lookupMemberVar(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberVarShort((WParameter)this, receiverType, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupFuncs(String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupFuncsShort((WParameter)this, name);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<de.peeeq.wurstscript.attributes.names.FuncLink> lookupMemberFuncs(de.peeeq.wurstscript.types.WurstType receiverType, String name) {
        return de.peeeq.wurstscript.attributes.names.NameResolution.lookupMemberFuncsShort((WParameter)this, receiverType, name);
    }
    /** */
    public String attrComment() {
        return de.peeeq.wurstscript.attributes.AttrWurstDoc.getComment((WParameter)this);
    }
    /** */
    public com.google.common.collect.ImmutableCollection<WPackage> attrUsedPackages() {
        return de.peeeq.wurstscript.attributes.UsedPackages.usedPackages((WParameter)this);
    }
    /** */
    public String description() {
        return de.peeeq.wurstscript.attributes.Description.description((WParameter)this);
    }
    /** */
    public String descriptionHtml() {
        return de.peeeq.wurstscript.attributes.DescriptionHtml.description((WParameter)this);
    }
    /** */
    public boolean isSubtreeOf(Element other) {
        return de.peeeq.wurstscript.attributes.SmallHelpers.isSubtreeOf((WParameter)this, other);
    }
    /** */
    public void prettyPrint(de.peeeq.wurstscript.attributes.prettyPrint.Spacer spacer, StringBuilder sb, int indent) {
        de.peeeq.wurstscript.attributes.prettyPrint.PrettyPrinter.prettyPrint((WParameter)this, spacer, sb, indent);
    }
    /** */
    public String getName() {
        return de.peeeq.wurstscript.attributes.SmallHelpers.getName((WParameter)this);
    }
}
