//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class JassExprBinaryImpl implements JassExprBinary{
    JassExprBinaryImpl(JassExpr leftExpr, JassOpBinary op, JassExpr right) {
        if (leftExpr == null)
            throw new IllegalArgumentException("Element leftExpr must not be null.");
        if (op == null)
            throw new IllegalArgumentException("Element op must not be null.");
        if (right == null)
            throw new IllegalArgumentException("Element right must not be null.");
        this.leftExpr = leftExpr;
        this.op = op;
        this.right = right;
        leftExpr.setParent(this);
        op.setParent(this);
        right.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private JassExpr leftExpr;
    public void setLeftExpr(JassExpr leftExpr) {
        if (leftExpr == null) throw new IllegalArgumentException();
        this.leftExpr.setParent(null);
        leftExpr.setParent(this);
        this.leftExpr = leftExpr;
    } 
    public JassExpr getLeftExpr() { return leftExpr; }

    private JassOpBinary op;
    public void setOp(JassOpBinary op) {
        if (op == null) throw new IllegalArgumentException();
        this.op.setParent(null);
        op.setParent(this);
        this.op = op;
    } 
    public JassOpBinary getOp() { return op; }

    private JassExpr right;
    public void setRight(JassExpr right) {
        if (right == null) throw new IllegalArgumentException();
        this.right.setParent(null);
        right.setParent(this);
        this.right = right;
    } 
    public JassExpr getRight() { return right; }

    public Element get(int i) {
        switch (i) {
            case 0: return leftExpr;
            case 1: return op;
            case 2: return right;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = leftExpr; setLeftExpr((JassExpr) newElem); return oldElem;
            case 1: oldElem = op; setOp((JassOpBinary) newElem); return oldElem;
            case 2: oldElem = right; setRight((JassExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.leftExpr);
        action.accept(this.op);
        action.accept(this.right);
    }
    public int size() {
        return 3;
    }
    @Override public JassExprBinary copy() {
        JassExprBinary result = new JassExprBinaryImpl((JassExpr) this.leftExpr.copy(), (JassOpBinary) this.op.copy(), (JassExpr) this.right.copy());
        return result;
    }

    @Override public JassExprBinary copyWithRefs() {
        JassExprBinary res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        leftExpr.clearAttributes();
        op.clearAttributes();
        right.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_getLine_state = 0;
        zzattr_getProg_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_JassExprBinary(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_JassExprBinary(this);
    }

    @Override public <T> T match(JassExpr.Matcher<T> matcher) {
        return matcher.case_JassExprBinary(this);
    }
    @Override public void match(JassExpr.MatcherVoid matcher) {
        matcher.case_JassExprBinary(this);
    }

    @Override public String toString() {
        return "JassExprBinary(" + leftExpr + ", " +op + ", " +right+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof JassExprBinary) {
            JassExprBinary o = (JassExprBinary) e;
            return this.leftExpr.structuralEquals(o.getLeftExpr())
                && this.op.structuralEquals(o.getOp())
                && this.right.structuralEquals(o.getRight());
        } else {
            return false;
        }
    }
    /** */
    public String getType() {
        return de.peeeq.wurstscript.frotty.jassAttributes.JassExprAttr.getType((JassExprBinary)this);
    }
// circular = null
    private int zzattr_getLine_state = 0;
    private int zzattr_getLine_cache;
    /** */
    public int getLine() {
        if (zzattr_getLine_state == 0) {
            try {
                zzattr_getLine_state = 1;
                zzattr_getLine_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getLine((JassExprBinary)this);
            } finally {
                zzattr_getLine_state = 0;
            }
            zzattr_getLine_state = 2;
        } else if (zzattr_getLine_state == 1) {
            throw new CyclicDependencyError(this, "getLine");
        }
        return zzattr_getLine_cache;
    }
// circular = null
    private int zzattr_getProg_state = 0;
    private JassProg zzattr_getProg_cache;
    /** */
    public JassProg getProg() {
        if (zzattr_getProg_state == 0) {
            try {
                zzattr_getProg_state = 1;
                zzattr_getProg_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getProg((JassExprBinary)this);
            } finally {
                zzattr_getProg_state = 0;
            }
            zzattr_getProg_state = 2;
        } else if (zzattr_getProg_state == 1) {
            throw new CyclicDependencyError(this, "getProg");
        }
        return zzattr_getProg_cache;
    }
    /** */
    public void print(java.lang.StringBuilder sb, boolean withSpace) {
        de.peeeq.wurstscript.jassprinter.ExprPrinter.print((JassExprBinary)this, sb, withSpace);
    }
}
