//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class JassNativeImpl implements JassNative{
    JassNativeImpl(String name, JassSimpleVars params, String returnType) {
        if (name == null)
            throw new IllegalArgumentException("Element name must not be null.");
        if (params == null)
            throw new IllegalArgumentException("Element params must not be null.");
        if (returnType == null)
            throw new IllegalArgumentException("Element returnType must not be null.");
        this.name = name;
        this.params = params;
        this.returnType = returnType;
        params.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private String name;
    public void setName(String name) {
        if (name == null) throw new IllegalArgumentException();
        this.name = name;
    } 
    public String getName() { return name; }

    private JassSimpleVars params;
    public void setParams(JassSimpleVars params) {
        if (params == null) throw new IllegalArgumentException();
        this.params.setParent(null);
        params.setParent(this);
        this.params = params;
    } 
    public JassSimpleVars getParams() { return params; }

    private String returnType;
    public void setReturnType(String returnType) {
        if (returnType == null) throw new IllegalArgumentException();
        this.returnType = returnType;
    } 
    public String getReturnType() { return returnType; }

    public Element get(int i) {
        switch (i) {
            case 0: return params;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = params; setParams((JassSimpleVars) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.params);
    }
    public int size() {
        return 1;
    }
    @Override public JassNative copy() {
        JassNative result = new JassNativeImpl(name, (JassSimpleVars) this.params.copy(), returnType);
        return result;
    }

    @Override public JassNative copyWithRefs() {
        JassNative res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        params.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_getLine_state = 0;
        zzattr_getProg_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(JassFunctionOrNative.Matcher<T> matcher) {
        return matcher.case_JassNative(this);
    }
    @Override public void match(JassFunctionOrNative.MatcherVoid matcher) {
        matcher.case_JassNative(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_JassNative(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_JassNative(this);
    }

    @Override public String toString() {
        return "JassNative(" + name + ", " +params + ", " +returnType+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof JassNative) {
            JassNative o = (JassNative) e;
            return java.util.Objects.equals(name, o.getName())
                && this.params.structuralEquals(o.getParams())
                && java.util.Objects.equals(returnType, o.getReturnType());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_getLine_state = 0;
    private int zzattr_getLine_cache;
    /** */
    public int getLine() {
        if (zzattr_getLine_state == 0) {
            try {
                zzattr_getLine_state = 1;
                zzattr_getLine_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getLine((JassNative)this);
            } finally {
                zzattr_getLine_state = 0;
            }
            zzattr_getLine_state = 2;
        } else if (zzattr_getLine_state == 1) {
            throw new CyclicDependencyError(this, "getLine");
        }
        return zzattr_getLine_cache;
    }
// circular = null
    private int zzattr_getProg_state = 0;
    private JassProg zzattr_getProg_cache;
    /** */
    public JassProg getProg() {
        if (zzattr_getProg_state == 0) {
            try {
                zzattr_getProg_state = 1;
                zzattr_getProg_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getProg((JassNative)this);
            } finally {
                zzattr_getProg_state = 0;
            }
            zzattr_getProg_state = 2;
        } else if (zzattr_getProg_state == 1) {
            throw new CyclicDependencyError(this, "getProg");
        }
        return zzattr_getProg_cache;
    }
    /** */
    public void print(java.lang.StringBuilder sb, boolean withSpace) {
        de.peeeq.wurstscript.jassprinter.JassPrinter.printNative((JassNative)this, sb, withSpace);
    }
}
