//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class JassProgImpl implements JassProg{
    JassProgImpl(JassTypeDefs defs, JassVars globals, JassNatives natives, JassFunctions functions) {
        if (defs == null)
            throw new IllegalArgumentException("Element defs must not be null.");
        if (globals == null)
            throw new IllegalArgumentException("Element globals must not be null.");
        if (natives == null)
            throw new IllegalArgumentException("Element natives must not be null.");
        if (functions == null)
            throw new IllegalArgumentException("Element functions must not be null.");
        this.defs = defs;
        this.globals = globals;
        this.natives = natives;
        this.functions = functions;
        defs.setParent(this);
        globals.setParent(this);
        natives.setParent(this);
        functions.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private JassTypeDefs defs;
    public void setDefs(JassTypeDefs defs) {
        if (defs == null) throw new IllegalArgumentException();
        this.defs.setParent(null);
        defs.setParent(this);
        this.defs = defs;
    } 
    public JassTypeDefs getDefs() { return defs; }

    private JassVars globals;
    public void setGlobals(JassVars globals) {
        if (globals == null) throw new IllegalArgumentException();
        this.globals.setParent(null);
        globals.setParent(this);
        this.globals = globals;
    } 
    public JassVars getGlobals() { return globals; }

    private JassNatives natives;
    public void setNatives(JassNatives natives) {
        if (natives == null) throw new IllegalArgumentException();
        this.natives.setParent(null);
        natives.setParent(this);
        this.natives = natives;
    } 
    public JassNatives getNatives() { return natives; }

    private JassFunctions functions;
    public void setFunctions(JassFunctions functions) {
        if (functions == null) throw new IllegalArgumentException();
        this.functions.setParent(null);
        functions.setParent(this);
        this.functions = functions;
    } 
    public JassFunctions getFunctions() { return functions; }

    public Element get(int i) {
        switch (i) {
            case 0: return defs;
            case 1: return globals;
            case 2: return natives;
            case 3: return functions;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = defs; setDefs((JassTypeDefs) newElem); return oldElem;
            case 1: oldElem = globals; setGlobals((JassVars) newElem); return oldElem;
            case 2: oldElem = natives; setNatives((JassNatives) newElem); return oldElem;
            case 3: oldElem = functions; setFunctions((JassFunctions) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.defs);
        action.accept(this.globals);
        action.accept(this.natives);
        action.accept(this.functions);
    }
    public int size() {
        return 4;
    }
    @Override public JassProg copy() {
        JassProg result = new JassProgImpl((JassTypeDefs) this.defs.copy(), (JassVars) this.globals.copy(), (JassNatives) this.natives.copy(), (JassFunctions) this.functions.copy());
        return result;
    }

    @Override public JassProg copyWithRefs() {
        JassProg res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        defs.clearAttributes();
        globals.clearAttributes();
        natives.clearAttributes();
        functions.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_getLine_state = 0;
        zzattr_getProg_state = 0;
        zzattr_attrLineMap_state = 0;
        zzattr_attrIgnoredVariables_state = 0;
        zzattr_attrComments_state = 0;
        zzattr_attrIgnoredFunctions_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(JassScope.Matcher<T> matcher) {
        return matcher.case_JassProg(this);
    }
    @Override public void match(JassScope.MatcherVoid matcher) {
        matcher.case_JassProg(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_JassProg(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_JassProg(this);
    }

    @Override public String toString() {
        return "JassProg(" + defs + ", " +globals + ", " +natives + ", " +functions+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof JassProg) {
            JassProg o = (JassProg) e;
            return this.defs.structuralEquals(o.getDefs())
                && this.globals.structuralEquals(o.getGlobals())
                && this.natives.structuralEquals(o.getNatives())
                && this.functions.structuralEquals(o.getFunctions());
        } else {
            return false;
        }
    }
    /** */
    public void validate() {
        de.peeeq.wurstscript.frotty.jassValidator.JassValidator.validate((JassProg)this);
    }
// circular = null
    private int zzattr_getLine_state = 0;
    private int zzattr_getLine_cache;
    /** */
    public int getLine() {
        if (zzattr_getLine_state == 0) {
            try {
                zzattr_getLine_state = 1;
                zzattr_getLine_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getLine((JassProg)this);
            } finally {
                zzattr_getLine_state = 0;
            }
            zzattr_getLine_state = 2;
        } else if (zzattr_getLine_state == 1) {
            throw new CyclicDependencyError(this, "getLine");
        }
        return zzattr_getLine_cache;
    }
// circular = null
    private int zzattr_getProg_state = 0;
    private JassProg zzattr_getProg_cache;
    /** */
    public JassProg getProg() {
        if (zzattr_getProg_state == 0) {
            try {
                zzattr_getProg_state = 1;
                zzattr_getProg_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getProg((JassProg)this);
            } finally {
                zzattr_getProg_state = 0;
            }
            zzattr_getProg_state = 2;
        } else if (zzattr_getProg_state == 1) {
            throw new CyclicDependencyError(this, "getProg");
        }
        return zzattr_getProg_cache;
    }
// circular = null
    private int zzattr_attrLineMap_state = 0;
    private java.util.Map<Element, Integer> zzattr_attrLineMap_cache;
    /** */
    public java.util.Map<Element, Integer> attrLineMap() {
        if (zzattr_attrLineMap_state == 0) {
            try {
                zzattr_attrLineMap_state = 1;
                zzattr_attrLineMap_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.get((JassProg)this);
            } finally {
                zzattr_attrLineMap_state = 0;
            }
            zzattr_attrLineMap_state = 2;
        } else if (zzattr_attrLineMap_state == 1) {
            throw new CyclicDependencyError(this, "attrLineMap");
        }
        return zzattr_attrLineMap_cache;
    }
// circular = null
    private int zzattr_attrIgnoredVariables_state = 0;
    private java.util.Set<JassVar> zzattr_attrIgnoredVariables_cache;
    /** */
    public java.util.Set<JassVar> attrIgnoredVariables() {
        if (zzattr_attrIgnoredVariables_state == 0) {
            try {
                zzattr_attrIgnoredVariables_state = 1;
                zzattr_attrIgnoredVariables_cache = de.peeeq.wurstscript.attributes.JassAttributes.attrIgnoredVariables((JassProg)this);
            } finally {
                zzattr_attrIgnoredVariables_state = 0;
            }
            zzattr_attrIgnoredVariables_state = 2;
        } else if (zzattr_attrIgnoredVariables_state == 1) {
            throw new CyclicDependencyError(this, "attrIgnoredVariables");
        }
        return zzattr_attrIgnoredVariables_cache;
    }
// circular = null
    private int zzattr_attrComments_state = 0;
    private java.util.Map<Element, String> zzattr_attrComments_cache;
    /** */
    public java.util.Map<Element, String> attrComments() {
        if (zzattr_attrComments_state == 0) {
            try {
                zzattr_attrComments_state = 1;
                zzattr_attrComments_cache = de.peeeq.wurstscript.attributes.JassAttributes.attrComments((JassProg)this);
            } finally {
                zzattr_attrComments_state = 0;
            }
            zzattr_attrComments_state = 2;
        } else if (zzattr_attrComments_state == 1) {
            throw new CyclicDependencyError(this, "attrComments");
        }
        return zzattr_attrComments_cache;
    }
// circular = null
    private int zzattr_attrIgnoredFunctions_state = 0;
    private java.util.Set<JassFunction> zzattr_attrIgnoredFunctions_cache;
    /** */
    public java.util.Set<JassFunction> attrIgnoredFunctions() {
        if (zzattr_attrIgnoredFunctions_state == 0) {
            try {
                zzattr_attrIgnoredFunctions_state = 1;
                zzattr_attrIgnoredFunctions_cache = de.peeeq.wurstscript.attributes.JassAttributes.attrIgnoredFunctions((JassProg)this);
            } finally {
                zzattr_attrIgnoredFunctions_state = 0;
            }
            zzattr_attrIgnoredFunctions_state = 2;
        } else if (zzattr_attrIgnoredFunctions_state == 1) {
            throw new CyclicDependencyError(this, "attrIgnoredFunctions");
        }
        return zzattr_attrIgnoredFunctions_cache;
    }
}
