//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class JassStmtCallImpl implements JassStmtCall{
    JassStmtCallImpl(String funcName, JassExprlist arguments) {
        if (funcName == null)
            throw new IllegalArgumentException("Element funcName must not be null.");
        if (arguments == null)
            throw new IllegalArgumentException("Element arguments must not be null.");
        this.funcName = funcName;
        this.arguments = arguments;
        arguments.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private String funcName;
    public void setFuncName(String funcName) {
        if (funcName == null) throw new IllegalArgumentException();
        this.funcName = funcName;
    } 
    public String getFuncName() { return funcName; }

    private JassExprlist arguments;
    public void setArguments(JassExprlist arguments) {
        if (arguments == null) throw new IllegalArgumentException();
        this.arguments.setParent(null);
        arguments.setParent(this);
        this.arguments = arguments;
    } 
    public JassExprlist getArguments() { return arguments; }

    public Element get(int i) {
        switch (i) {
            case 0: return arguments;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = arguments; setArguments((JassExprlist) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.arguments);
    }
    public int size() {
        return 1;
    }
    @Override public JassStmtCall copy() {
        JassStmtCall result = new JassStmtCallImpl(funcName, (JassExprlist) this.arguments.copy());
        return result;
    }

    @Override public JassStmtCall copyWithRefs() {
        JassStmtCall res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        arguments.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_getLine_state = 0;
        zzattr_getProg_state = 0;
        zzattr_attrFunctionCall_state = 0;
        zzattr_attrFuncDef_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(JassFuncRef.Matcher<T> matcher) {
        return matcher.case_JassStmtCall(this);
    }
    @Override public void match(JassFuncRef.MatcherVoid matcher) {
        matcher.case_JassStmtCall(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_JassStmtCall(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_JassStmtCall(this);
    }

    @Override public <T> T match(JassStatement.Matcher<T> matcher) {
        return matcher.case_JassStmtCall(this);
    }
    @Override public void match(JassStatement.MatcherVoid matcher) {
        matcher.case_JassStmtCall(this);
    }

    @Override public String toString() {
        return "JassStmtCall(" + funcName + ", " +arguments+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof JassStmtCall) {
            JassStmtCall o = (JassStmtCall) e;
            return java.util.Objects.equals(funcName, o.getFuncName())
                && this.arguments.structuralEquals(o.getArguments());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_getLine_state = 0;
    private int zzattr_getLine_cache;
    /** */
    public int getLine() {
        if (zzattr_getLine_state == 0) {
            try {
                zzattr_getLine_state = 1;
                zzattr_getLine_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getLine((JassStmtCall)this);
            } finally {
                zzattr_getLine_state = 0;
            }
            zzattr_getLine_state = 2;
        } else if (zzattr_getLine_state == 1) {
            throw new CyclicDependencyError(this, "getLine");
        }
        return zzattr_getLine_cache;
    }
// circular = null
    private int zzattr_getProg_state = 0;
    private JassProg zzattr_getProg_cache;
    /** */
    public JassProg getProg() {
        if (zzattr_getProg_state == 0) {
            try {
                zzattr_getProg_state = 1;
                zzattr_getProg_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getProg((JassStmtCall)this);
            } finally {
                zzattr_getProg_state = 0;
            }
            zzattr_getProg_state = 2;
        } else if (zzattr_getProg_state == 1) {
            throw new CyclicDependencyError(this, "getProg");
        }
        return zzattr_getProg_cache;
    }
// circular = null
    private int zzattr_attrFunctionCall_state = 0;
    private JassFunction zzattr_attrFunctionCall_cache;
    /** "gets the function for a function call"*/
    public JassFunction attrFunctionCall() {
        if (zzattr_attrFunctionCall_state == 0) {
            try {
                zzattr_attrFunctionCall_state = 1;
                zzattr_attrFunctionCall_cache = de.peeeq.wurstscript.frotty.jassAttributes.FunctionCall.get((JassStmtCall)this);
            } finally {
                zzattr_attrFunctionCall_state = 0;
            }
            zzattr_attrFunctionCall_state = 2;
        } else if (zzattr_attrFunctionCall_state == 1) {
            throw new CyclicDependencyError(this, "attrFunctionCall");
        }
        return zzattr_attrFunctionCall_cache;
    }
// circular = null
    private int zzattr_attrFuncDef_state = 0;
    private JassFunction zzattr_attrFuncDef_cache;
    /** */
    public JassFunction attrFuncDef() {
        if (zzattr_attrFuncDef_state == 0) {
            try {
                zzattr_attrFuncDef_state = 1;
                zzattr_attrFuncDef_cache = de.peeeq.wurstscript.attributes.JassAttributes.attrFuncDef((JassStmtCall)this);
            } finally {
                zzattr_attrFuncDef_state = 0;
            }
            zzattr_attrFuncDef_state = 2;
        } else if (zzattr_attrFuncDef_state == 1) {
            throw new CyclicDependencyError(this, "attrFuncDef");
        }
        return zzattr_attrFuncDef_cache;
    }
    /** */
    public void print(java.lang.StringBuilder sb, int indent, boolean withSpace) {
        de.peeeq.wurstscript.jassprinter.StatementPrinter.print((JassStmtCall)this, sb, indent, withSpace);
    }
}
