//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class JassStmtIfImpl implements JassStmtIf{
    JassStmtIfImpl(JassExpr cond, JassStatements thenBlock, JassStatements elseBlock) {
        if (cond == null)
            throw new IllegalArgumentException("Element cond must not be null.");
        if (thenBlock == null)
            throw new IllegalArgumentException("Element thenBlock must not be null.");
        if (elseBlock == null)
            throw new IllegalArgumentException("Element elseBlock must not be null.");
        this.cond = cond;
        this.thenBlock = thenBlock;
        this.elseBlock = elseBlock;
        cond.setParent(this);
        thenBlock.setParent(this);
        elseBlock.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private JassExpr cond;
    public void setCond(JassExpr cond) {
        if (cond == null) throw new IllegalArgumentException();
        this.cond.setParent(null);
        cond.setParent(this);
        this.cond = cond;
    } 
    public JassExpr getCond() { return cond; }

    private JassStatements thenBlock;
    public void setThenBlock(JassStatements thenBlock) {
        if (thenBlock == null) throw new IllegalArgumentException();
        this.thenBlock.setParent(null);
        thenBlock.setParent(this);
        this.thenBlock = thenBlock;
    } 
    public JassStatements getThenBlock() { return thenBlock; }

    private JassStatements elseBlock;
    public void setElseBlock(JassStatements elseBlock) {
        if (elseBlock == null) throw new IllegalArgumentException();
        this.elseBlock.setParent(null);
        elseBlock.setParent(this);
        this.elseBlock = elseBlock;
    } 
    public JassStatements getElseBlock() { return elseBlock; }

    public Element get(int i) {
        switch (i) {
            case 0: return cond;
            case 1: return thenBlock;
            case 2: return elseBlock;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = cond; setCond((JassExpr) newElem); return oldElem;
            case 1: oldElem = thenBlock; setThenBlock((JassStatements) newElem); return oldElem;
            case 2: oldElem = elseBlock; setElseBlock((JassStatements) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.cond);
        action.accept(this.thenBlock);
        action.accept(this.elseBlock);
    }
    public int size() {
        return 3;
    }
    @Override public JassStmtIf copy() {
        JassStmtIf result = new JassStmtIfImpl((JassExpr) this.cond.copy(), (JassStatements) this.thenBlock.copy(), (JassStatements) this.elseBlock.copy());
        return result;
    }

    @Override public JassStmtIf copyWithRefs() {
        JassStmtIf res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        cond.clearAttributes();
        thenBlock.clearAttributes();
        elseBlock.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_getLine_state = 0;
        zzattr_getProg_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_JassStmtIf(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_JassStmtIf(this);
    }

    @Override public <T> T match(JassStatement.Matcher<T> matcher) {
        return matcher.case_JassStmtIf(this);
    }
    @Override public void match(JassStatement.MatcherVoid matcher) {
        matcher.case_JassStmtIf(this);
    }

    @Override public String toString() {
        return "JassStmtIf(" + cond + ", " +thenBlock + ", " +elseBlock+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof JassStmtIf) {
            JassStmtIf o = (JassStmtIf) e;
            return this.cond.structuralEquals(o.getCond())
                && this.thenBlock.structuralEquals(o.getThenBlock())
                && this.elseBlock.structuralEquals(o.getElseBlock());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_getLine_state = 0;
    private int zzattr_getLine_cache;
    /** */
    public int getLine() {
        if (zzattr_getLine_state == 0) {
            try {
                zzattr_getLine_state = 1;
                zzattr_getLine_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getLine((JassStmtIf)this);
            } finally {
                zzattr_getLine_state = 0;
            }
            zzattr_getLine_state = 2;
        } else if (zzattr_getLine_state == 1) {
            throw new CyclicDependencyError(this, "getLine");
        }
        return zzattr_getLine_cache;
    }
// circular = null
    private int zzattr_getProg_state = 0;
    private JassProg zzattr_getProg_cache;
    /** */
    public JassProg getProg() {
        if (zzattr_getProg_state == 0) {
            try {
                zzattr_getProg_state = 1;
                zzattr_getProg_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getProg((JassStmtIf)this);
            } finally {
                zzattr_getProg_state = 0;
            }
            zzattr_getProg_state = 2;
        } else if (zzattr_getProg_state == 1) {
            throw new CyclicDependencyError(this, "getProg");
        }
        return zzattr_getProg_cache;
    }
    /** */
    public void print(java.lang.StringBuilder sb, int indent, boolean withSpace) {
        de.peeeq.wurstscript.jassprinter.StatementPrinter.print((JassStmtIf)this, sb, indent, withSpace);
    }
}
