//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class JassStmtSetArrayImpl implements JassStmtSetArray{
    JassStmtSetArrayImpl(String left, JassExpr index, JassExpr right) {
        if (left == null)
            throw new IllegalArgumentException("Element left must not be null.");
        if (index == null)
            throw new IllegalArgumentException("Element index must not be null.");
        if (right == null)
            throw new IllegalArgumentException("Element right must not be null.");
        this.left = left;
        this.index = index;
        this.right = right;
        index.setParent(this);
        right.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private String left;
    public void setLeft(String left) {
        if (left == null) throw new IllegalArgumentException();
        this.left = left;
    } 
    public String getLeft() { return left; }

    private JassExpr index;
    public void setIndex(JassExpr index) {
        if (index == null) throw new IllegalArgumentException();
        this.index.setParent(null);
        index.setParent(this);
        this.index = index;
    } 
    public JassExpr getIndex() { return index; }

    private JassExpr right;
    public void setRight(JassExpr right) {
        if (right == null) throw new IllegalArgumentException();
        this.right.setParent(null);
        right.setParent(this);
        this.right = right;
    } 
    public JassExpr getRight() { return right; }

    public Element get(int i) {
        switch (i) {
            case 0: return index;
            case 1: return right;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = index; setIndex((JassExpr) newElem); return oldElem;
            case 1: oldElem = right; setRight((JassExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.index);
        action.accept(this.right);
    }
    public int size() {
        return 2;
    }
    @Override public JassStmtSetArray copy() {
        JassStmtSetArray result = new JassStmtSetArrayImpl(left, (JassExpr) this.index.copy(), (JassExpr) this.right.copy());
        return result;
    }

    @Override public JassStmtSetArray copyWithRefs() {
        JassStmtSetArray res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        index.clearAttributes();
        right.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
        zzattr_getLine_state = 0;
        zzattr_getProg_state = 0;
        zzattr_attrVariableDefinition_state = 0;
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_JassStmtSetArray(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_JassStmtSetArray(this);
    }

    @Override public <T> T match(JassStatement.Matcher<T> matcher) {
        return matcher.case_JassStmtSetArray(this);
    }
    @Override public void match(JassStatement.MatcherVoid matcher) {
        matcher.case_JassStmtSetArray(this);
    }

    @Override public String toString() {
        return "JassStmtSetArray(" + left + ", " +index + ", " +right+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof JassStmtSetArray) {
            JassStmtSetArray o = (JassStmtSetArray) e;
            return java.util.Objects.equals(left, o.getLeft())
                && this.index.structuralEquals(o.getIndex())
                && this.right.structuralEquals(o.getRight());
        } else {
            return false;
        }
    }
// circular = null
    private int zzattr_getLine_state = 0;
    private int zzattr_getLine_cache;
    /** */
    public int getLine() {
        if (zzattr_getLine_state == 0) {
            try {
                zzattr_getLine_state = 1;
                zzattr_getLine_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getLine((JassStmtSetArray)this);
            } finally {
                zzattr_getLine_state = 0;
            }
            zzattr_getLine_state = 2;
        } else if (zzattr_getLine_state == 1) {
            throw new CyclicDependencyError(this, "getLine");
        }
        return zzattr_getLine_cache;
    }
// circular = null
    private int zzattr_getProg_state = 0;
    private JassProg zzattr_getProg_cache;
    /** */
    public JassProg getProg() {
        if (zzattr_getProg_state == 0) {
            try {
                zzattr_getProg_state = 1;
                zzattr_getProg_cache = de.peeeq.wurstscript.frotty.jassValidator.LineMapAttr.getProg((JassStmtSetArray)this);
            } finally {
                zzattr_getProg_state = 0;
            }
            zzattr_getProg_state = 2;
        } else if (zzattr_getProg_state == 1) {
            throw new CyclicDependencyError(this, "getProg");
        }
        return zzattr_getProg_cache;
    }
// circular = null
    private int zzattr_attrVariableDefinition_state = 0;
    private JassStmtSetArray zzattr_attrVariableDefinition_cache;
    /** "gets the var for a variable reference"*/
    public JassStmtSetArray attrVariableDefinition() {
        if (zzattr_attrVariableDefinition_state == 0) {
            try {
                zzattr_attrVariableDefinition_state = 1;
                zzattr_attrVariableDefinition_cache = de.peeeq.wurstscript.frotty.jassAttributes.VariableDefinition.get((JassStmtSetArray)this);
            } finally {
                zzattr_attrVariableDefinition_state = 0;
            }
            zzattr_attrVariableDefinition_state = 2;
        } else if (zzattr_attrVariableDefinition_state == 1) {
            throw new CyclicDependencyError(this, "attrVariableDefinition");
        }
        return zzattr_attrVariableDefinition_cache;
    }
    /** */
    public void print(java.lang.StringBuilder sb, int indent, boolean withSpace) {
        de.peeeq.wurstscript.jassprinter.StatementPrinter.print((JassStmtSetArray)this, sb, indent, withSpace);
    }
}
