//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassIm;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class ImCastImpl implements ImCast{
    ImCastImpl(ImExpr expr, ImType toType) {
        if (expr == null)
            throw new IllegalArgumentException("Element expr must not be null.");
        if (toType == null)
            throw new IllegalArgumentException("Element toType must not be null.");
        this.expr = expr;
        this.toType = toType;
        expr.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private ImExpr expr;
    public void setExpr(ImExpr expr) {
        if (expr == null) throw new IllegalArgumentException();
        this.expr.setParent(null);
        expr.setParent(this);
        this.expr = expr;
    } 
    public ImExpr getExpr() { return expr; }

    private ImType toType;
    public void setToType(ImType toType) {
        if (toType == null) throw new IllegalArgumentException();
        this.toType = toType;
    } 
    public ImType getToType() { return toType; }

    public Element get(int i) {
        switch (i) {
            case 0: return expr;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = expr; setExpr((ImExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.expr);
    }
    public int size() {
        return 1;
    }
    @Override public ImCast copy() {
        ImCast result = new ImCastImpl((ImExpr) this.expr.copy(), toType);
        return result;
    }

    @Override public ImCast copyWithRefs() {
        ImCast res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        expr.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(ImExprOpt.Matcher<T> matcher) {
        return matcher.case_ImCast(this);
    }
    @Override public void match(ImExprOpt.MatcherVoid matcher) {
        matcher.case_ImCast(this);
    }

    @Override public <T> T match(ImStmt.Matcher<T> matcher) {
        return matcher.case_ImCast(this);
    }
    @Override public void match(ImStmt.MatcherVoid matcher) {
        matcher.case_ImCast(this);
    }

    @Override public <T> T match(ImPrintable.Matcher<T> matcher) {
        return matcher.case_ImCast(this);
    }
    @Override public void match(ImPrintable.MatcherVoid matcher) {
        matcher.case_ImCast(this);
    }

    @Override public <T> T match(ImExpr.Matcher<T> matcher) {
        return matcher.case_ImCast(this);
    }
    @Override public void match(ImExpr.MatcherVoid matcher) {
        matcher.case_ImCast(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_ImCast(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_ImCast(this);
    }

    public boolean structuralEquals(Element e) {
        if (e instanceof ImCast) {
            ImCast o = (ImCast) e;
            return this.expr.structuralEquals(o.getExpr())
                && this.toType == o.getToType();
        } else {
            return false;
        }
    }
    /** */
    public void print(java.lang.Appendable sb, int indent) {
        de.peeeq.wurstscript.translation.imtranslation.ImPrinter.print((ImCast)this, sb, indent);
    }
    /** */
    public String toString() {
        return de.peeeq.wurstscript.translation.imtranslation.ImPrinter.asString((ImCast)this);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.Flatten.Result flatten(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.Flatten.flatten((ImCast)this, translator, f);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevel attrPurity() {
        return de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevels.calculate((ImCast)this);
    }
    /** */
    public void translate(java.util.List<de.peeeq.wurstscript.jassAst.JassStatement> stmts, de.peeeq.wurstscript.jassAst.JassFunction f, de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        de.peeeq.wurstscript.translation.imtojass.StatementTranslation.translate((ImCast)this, stmts, f, translator);
    }
    /** */
    public de.peeeq.wurstscript.jassAst.JassExpr translate(de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        return de.peeeq.wurstscript.translation.imtojass.ExprTranslation.translate((ImCast)this, translator);
    }
    /** */
    public ImType attrTyp() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttrType.getType((ImCast)this);
    }
    /** */
    public ImFunction getNearestFunc() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getNearestFunc((ImCast)this);
    }
    /** */
    public void translateStmtToLua(java.util.List<de.peeeq.wurstscript.luaAst.LuaStatement> res, de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        de.peeeq.wurstscript.translation.lua.translation.StmtTranslation.translate((ImCast)this, res, tr);
    }
    /** */
    public de.peeeq.wurstscript.luaAst.LuaExpr translateToLua(de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        return de.peeeq.wurstscript.translation.lua.translation.ExprTranslation.translate((ImCast)this, tr);
    }
    /** */
    public void runStatement(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        de.peeeq.wurstscript.intermediatelang.interpreter.RunStatement.run((ImCast)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.intermediatelang.ILconst evaluate(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        return de.peeeq.wurstscript.intermediatelang.interpreter.EvaluateExpr.eval((ImCast)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.ast.Element attrTrace() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getTrace((ImCast)this);
    }
    /** */
    public ImProg attrProg() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getProg((ImCast)this);
    }
}
