//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassIm;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class ImDeallocImpl implements ImDealloc{
    ImDeallocImpl(de.peeeq.wurstscript.ast.Element trace, ImClassType clazz, ImExpr obj) {
        if (trace == null)
            throw new IllegalArgumentException("Element trace must not be null.");
        if (clazz == null)
            throw new IllegalArgumentException("Element clazz must not be null.");
        if (obj == null)
            throw new IllegalArgumentException("Element obj must not be null.");
        this.trace = trace;
        this.clazz = clazz;
        this.obj = obj;
        obj.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.ast.Element trace;
    public void setTrace(de.peeeq.wurstscript.ast.Element trace) {
        if (trace == null) throw new IllegalArgumentException();
        this.trace = trace;
    } 
    public de.peeeq.wurstscript.ast.Element getTrace() { return trace; }

    private ImClassType clazz;
    public void setClazz(ImClassType clazz) {
        if (clazz == null) throw new IllegalArgumentException();
        this.clazz = clazz;
    } 
    public ImClassType getClazz() { return clazz; }

    private ImExpr obj;
    public void setObj(ImExpr obj) {
        if (obj == null) throw new IllegalArgumentException();
        this.obj.setParent(null);
        obj.setParent(this);
        this.obj = obj;
    } 
    public ImExpr getObj() { return obj; }

    public Element get(int i) {
        switch (i) {
            case 0: return obj;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = obj; setObj((ImExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.obj);
    }
    public int size() {
        return 1;
    }
    @Override public ImDealloc copy() {
        ImDealloc result = new ImDeallocImpl(trace, clazz, (ImExpr) this.obj.copy());
        return result;
    }

    @Override public ImDealloc copyWithRefs() {
        ImDealloc res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        obj.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(ImClassRelatedExprWithClass.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(ImClassRelatedExprWithClass.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    @Override public <T> T match(ElementWithTrace.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(ElementWithTrace.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    @Override public <T> T match(ImExprOpt.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(ImExprOpt.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    @Override public <T> T match(ImStmt.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(ImStmt.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    @Override public <T> T match(ImClassRelatedExpr.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(ImClassRelatedExpr.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    @Override public <T> T match(ImPrintable.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(ImPrintable.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    @Override public <T> T match(ImExpr.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(ImExpr.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_ImDealloc(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_ImDealloc(this);
    }

    public boolean structuralEquals(Element e) {
        if (e instanceof ImDealloc) {
            ImDealloc o = (ImDealloc) e;
            return this.clazz == o.getClazz()
                && this.obj.structuralEquals(o.getObj());
        } else {
            return false;
        }
    }
    /** */
    public void print(java.lang.Appendable sb, int indent) {
        de.peeeq.wurstscript.translation.imtranslation.ImPrinter.print((ImDealloc)this, sb, indent);
    }
    /** */
    public String toString() {
        return de.peeeq.wurstscript.translation.imtranslation.ImPrinter.asString((ImDealloc)this);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.Flatten.Result flatten(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.Flatten.flatten((ImDealloc)this, translator, f);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevel attrPurity() {
        return de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevels.calculate((ImDealloc)this);
    }
    /** */
    public void translate(java.util.List<de.peeeq.wurstscript.jassAst.JassStatement> stmts, de.peeeq.wurstscript.jassAst.JassFunction f, de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        de.peeeq.wurstscript.translation.imtojass.StatementTranslation.translate((ImDealloc)this, stmts, f, translator);
    }
    /** */
    public de.peeeq.wurstscript.jassAst.JassExpr translate(de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        return de.peeeq.wurstscript.translation.imtojass.ExprTranslation.translate((ImDealloc)this, translator);
    }
    /** */
    public ImType attrTyp() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttrType.getType((ImDealloc)this);
    }
    /** */
    public ImFunction getNearestFunc() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getNearestFunc((ImDealloc)this);
    }
    /** */
    public void translateStmtToLua(java.util.List<de.peeeq.wurstscript.luaAst.LuaStatement> res, de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        de.peeeq.wurstscript.translation.lua.translation.StmtTranslation.translate((ImDealloc)this, res, tr);
    }
    /** */
    public de.peeeq.wurstscript.luaAst.LuaExpr translateToLua(de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        return de.peeeq.wurstscript.translation.lua.translation.ExprTranslation.translate((ImDealloc)this, tr);
    }
    /** */
    public void runStatement(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        de.peeeq.wurstscript.intermediatelang.interpreter.RunStatement.run((ImDealloc)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.intermediatelang.ILconst evaluate(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        return de.peeeq.wurstscript.intermediatelang.interpreter.EvaluateExpr.eval((ImDealloc)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.ast.Element attrTrace() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getTrace((ImDealloc)this);
    }
    /** */
    public ImProg attrProg() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getProg((ImDealloc)this);
    }
}
