//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassIm;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class ImFunctionCallImpl implements ImFunctionCall{
    ImFunctionCallImpl(de.peeeq.wurstscript.ast.Element trace, ImFunction func, ImTypeArguments typeArguments, ImExprs arguments, boolean tuplesEliminated, de.peeeq.wurstscript.translation.imtranslation.CallType callType) {
        if (trace == null)
            throw new IllegalArgumentException("Element trace must not be null.");
        if (func == null)
            throw new IllegalArgumentException("Element func must not be null.");
        if (typeArguments == null)
            throw new IllegalArgumentException("Element typeArguments must not be null.");
        if (arguments == null)
            throw new IllegalArgumentException("Element arguments must not be null.");
        if (callType == null)
            throw new IllegalArgumentException("Element callType must not be null.");
        this.trace = trace;
        this.func = func;
        this.typeArguments = typeArguments;
        this.arguments = arguments;
        this.tuplesEliminated = tuplesEliminated;
        this.callType = callType;
        typeArguments.setParent(this);
        arguments.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.ast.Element trace;
    public void setTrace(de.peeeq.wurstscript.ast.Element trace) {
        if (trace == null) throw new IllegalArgumentException();
        this.trace = trace;
    } 
    public de.peeeq.wurstscript.ast.Element getTrace() { return trace; }

    private ImFunction func;
    public void setFunc(ImFunction func) {
        if (func == null) throw new IllegalArgumentException();
        this.func = func;
    } 
    public ImFunction getFunc() { return func; }

    private ImTypeArguments typeArguments;
    public void setTypeArguments(ImTypeArguments typeArguments) {
        if (typeArguments == null) throw new IllegalArgumentException();
        this.typeArguments.setParent(null);
        typeArguments.setParent(this);
        this.typeArguments = typeArguments;
    } 
    public ImTypeArguments getTypeArguments() { return typeArguments; }

    private ImExprs arguments;
    public void setArguments(ImExprs arguments) {
        if (arguments == null) throw new IllegalArgumentException();
        this.arguments.setParent(null);
        arguments.setParent(this);
        this.arguments = arguments;
    } 
    public ImExprs getArguments() { return arguments; }

    private boolean tuplesEliminated;
    public void setTuplesEliminated(boolean tuplesEliminated) {
        this.tuplesEliminated = tuplesEliminated;
    } 
    public boolean getTuplesEliminated() { return tuplesEliminated; }

    private de.peeeq.wurstscript.translation.imtranslation.CallType callType;
    public void setCallType(de.peeeq.wurstscript.translation.imtranslation.CallType callType) {
        if (callType == null) throw new IllegalArgumentException();
        this.callType = callType;
    } 
    public de.peeeq.wurstscript.translation.imtranslation.CallType getCallType() { return callType; }

    public Element get(int i) {
        switch (i) {
            case 0: return typeArguments;
            case 1: return arguments;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = typeArguments; setTypeArguments((ImTypeArguments) newElem); return oldElem;
            case 1: oldElem = arguments; setArguments((ImExprs) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.typeArguments);
        action.accept(this.arguments);
    }
    public int size() {
        return 2;
    }
    @Override public ImFunctionCall copy() {
        ImFunctionCall result = new ImFunctionCallImpl(trace, func, (ImTypeArguments) this.typeArguments.copy(), (ImExprs) this.arguments.copy(), tuplesEliminated, callType);
        return result;
    }

    @Override public ImFunctionCall copyWithRefs() {
        ImFunctionCall res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        typeArguments.clearAttributes();
        arguments.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(ImCall.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(ImCall.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    @Override public <T> T match(ElementWithTrace.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(ElementWithTrace.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    @Override public <T> T match(ImExprOpt.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(ImExprOpt.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    @Override public <T> T match(ImStmt.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(ImStmt.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    @Override public <T> T match(ImFuncRefOrCall.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(ImFuncRefOrCall.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    @Override public <T> T match(ImPrintable.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(ImPrintable.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    @Override public <T> T match(ImExpr.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(ImExpr.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_ImFunctionCall(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_ImFunctionCall(this);
    }

    public boolean structuralEquals(Element e) {
        if (e instanceof ImFunctionCall) {
            ImFunctionCall o = (ImFunctionCall) e;
            return this.func == o.getFunc()
                && this.typeArguments.structuralEquals(o.getTypeArguments())
                && this.arguments.structuralEquals(o.getArguments())
                && java.util.Objects.equals(tuplesEliminated, o.getTuplesEliminated())
                && java.util.Objects.equals(callType, o.getCallType());
        } else {
            return false;
        }
    }
    /** */
    public void print(java.lang.Appendable sb, int indent) {
        de.peeeq.wurstscript.translation.imtranslation.ImPrinter.print((ImFunctionCall)this, sb, indent);
    }
    /** */
    public String toString() {
        return de.peeeq.wurstscript.translation.imtranslation.ImPrinter.asString((ImFunctionCall)this);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.Flatten.Result flatten(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.Flatten.flatten((ImFunctionCall)this, translator, f);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevel attrPurity() {
        return de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevels.calculate((ImFunctionCall)this);
    }
    /** */
    public void translate(java.util.List<de.peeeq.wurstscript.jassAst.JassStatement> stmts, de.peeeq.wurstscript.jassAst.JassFunction f, de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        de.peeeq.wurstscript.translation.imtojass.StatementTranslation.translate((ImFunctionCall)this, stmts, f, translator);
    }
    /** */
    public de.peeeq.wurstscript.jassAst.JassExpr translate(de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        return de.peeeq.wurstscript.translation.imtojass.ExprTranslation.translate((ImFunctionCall)this, translator);
    }
    /** */
    public ImType attrTyp() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttrType.getType((ImFunctionCall)this);
    }
    /** */
    public ImFunction getNearestFunc() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getNearestFunc((ImFunctionCall)this);
    }
    /** */
    public void translateStmtToLua(java.util.List<de.peeeq.wurstscript.luaAst.LuaStatement> res, de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        de.peeeq.wurstscript.translation.lua.translation.StmtTranslation.translate((ImFunctionCall)this, res, tr);
    }
    /** */
    public de.peeeq.wurstscript.luaAst.LuaExpr translateToLua(de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        return de.peeeq.wurstscript.translation.lua.translation.ExprTranslation.translate((ImFunctionCall)this, tr);
    }
    /** */
    public void runStatement(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        de.peeeq.wurstscript.intermediatelang.interpreter.RunStatement.run((ImFunctionCall)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.intermediatelang.ILconst evaluate(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        return de.peeeq.wurstscript.intermediatelang.interpreter.EvaluateExpr.eval((ImFunctionCall)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.ast.Element attrTrace() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getTrace((ImFunctionCall)this);
    }
    /** */
    public ImProg attrProg() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getProg((ImFunctionCall)this);
    }
}
