//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassIm;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class ImIfImpl implements ImIf{
    ImIfImpl(de.peeeq.wurstscript.ast.Element trace, ImExpr condition, ImStmts thenBlock, ImStmts elseBlock) {
        if (trace == null)
            throw new IllegalArgumentException("Element trace must not be null.");
        if (condition == null)
            throw new IllegalArgumentException("Element condition must not be null.");
        if (thenBlock == null)
            throw new IllegalArgumentException("Element thenBlock must not be null.");
        if (elseBlock == null)
            throw new IllegalArgumentException("Element elseBlock must not be null.");
        this.trace = trace;
        this.condition = condition;
        this.thenBlock = thenBlock;
        this.elseBlock = elseBlock;
        condition.setParent(this);
        thenBlock.setParent(this);
        elseBlock.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.ast.Element trace;
    public void setTrace(de.peeeq.wurstscript.ast.Element trace) {
        if (trace == null) throw new IllegalArgumentException();
        this.trace = trace;
    } 
    public de.peeeq.wurstscript.ast.Element getTrace() { return trace; }

    private ImExpr condition;
    public void setCondition(ImExpr condition) {
        if (condition == null) throw new IllegalArgumentException();
        this.condition.setParent(null);
        condition.setParent(this);
        this.condition = condition;
    } 
    public ImExpr getCondition() { return condition; }

    private ImStmts thenBlock;
    public void setThenBlock(ImStmts thenBlock) {
        if (thenBlock == null) throw new IllegalArgumentException();
        this.thenBlock.setParent(null);
        thenBlock.setParent(this);
        this.thenBlock = thenBlock;
    } 
    public ImStmts getThenBlock() { return thenBlock; }

    private ImStmts elseBlock;
    public void setElseBlock(ImStmts elseBlock) {
        if (elseBlock == null) throw new IllegalArgumentException();
        this.elseBlock.setParent(null);
        elseBlock.setParent(this);
        this.elseBlock = elseBlock;
    } 
    public ImStmts getElseBlock() { return elseBlock; }

    public Element get(int i) {
        switch (i) {
            case 0: return condition;
            case 1: return thenBlock;
            case 2: return elseBlock;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = condition; setCondition((ImExpr) newElem); return oldElem;
            case 1: oldElem = thenBlock; setThenBlock((ImStmts) newElem); return oldElem;
            case 2: oldElem = elseBlock; setElseBlock((ImStmts) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.condition);
        action.accept(this.thenBlock);
        action.accept(this.elseBlock);
    }
    public int size() {
        return 3;
    }
    @Override public ImIf copy() {
        ImIf result = new ImIfImpl(trace, (ImExpr) this.condition.copy(), (ImStmts) this.thenBlock.copy(), (ImStmts) this.elseBlock.copy());
        return result;
    }

    @Override public ImIf copyWithRefs() {
        ImIf res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        condition.clearAttributes();
        thenBlock.clearAttributes();
        elseBlock.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(ImStmt.Matcher<T> matcher) {
        return matcher.case_ImIf(this);
    }
    @Override public void match(ImStmt.MatcherVoid matcher) {
        matcher.case_ImIf(this);
    }

    @Override public <T> T match(ElementWithTrace.Matcher<T> matcher) {
        return matcher.case_ImIf(this);
    }
    @Override public void match(ElementWithTrace.MatcherVoid matcher) {
        matcher.case_ImIf(this);
    }

    @Override public <T> T match(ImPrintable.Matcher<T> matcher) {
        return matcher.case_ImIf(this);
    }
    @Override public void match(ImPrintable.MatcherVoid matcher) {
        matcher.case_ImIf(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_ImIf(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_ImIf(this);
    }

    public boolean structuralEquals(Element e) {
        if (e instanceof ImIf) {
            ImIf o = (ImIf) e;
            return this.condition.structuralEquals(o.getCondition())
                && this.thenBlock.structuralEquals(o.getThenBlock())
                && this.elseBlock.structuralEquals(o.getElseBlock());
        } else {
            return false;
        }
    }
    /** */
    public void print(java.lang.Appendable sb, int indent) {
        de.peeeq.wurstscript.translation.imtranslation.ImPrinter.print((ImIf)this, sb, indent);
    }
    /** */
    public String toString() {
        return de.peeeq.wurstscript.translation.imtranslation.ImPrinter.asString((ImIf)this);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.Flatten.Result flatten(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.Flatten.flatten((ImIf)this, translator, f);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevel attrPurity() {
        return de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevels.calculate((ImIf)this);
    }
    /** */
    public void translate(java.util.List<de.peeeq.wurstscript.jassAst.JassStatement> stmts, de.peeeq.wurstscript.jassAst.JassFunction f, de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        de.peeeq.wurstscript.translation.imtojass.StatementTranslation.translate((ImIf)this, stmts, f, translator);
    }
    /** */
    public ImFunction getNearestFunc() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getNearestFunc((ImIf)this);
    }
    /** */
    public void translateStmtToLua(java.util.List<de.peeeq.wurstscript.luaAst.LuaStatement> res, de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        de.peeeq.wurstscript.translation.lua.translation.StmtTranslation.translate((ImIf)this, res, tr);
    }
    /** */
    public void runStatement(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        de.peeeq.wurstscript.intermediatelang.interpreter.RunStatement.run((ImIf)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.ast.Element attrTrace() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getTrace((ImIf)this);
    }
    /** */
    public ImProg attrProg() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getProg((ImIf)this);
    }
}
