//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassIm;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class ImMethodCallImpl implements ImMethodCall{
    ImMethodCallImpl(de.peeeq.wurstscript.ast.Element trace, ImMethod method, ImTypeArguments typeArguments, ImExpr receiver, ImExprs arguments, boolean tuplesEliminated) {
        if (trace == null)
            throw new IllegalArgumentException("Element trace must not be null.");
        if (method == null)
            throw new IllegalArgumentException("Element method must not be null.");
        if (typeArguments == null)
            throw new IllegalArgumentException("Element typeArguments must not be null.");
        if (receiver == null)
            throw new IllegalArgumentException("Element receiver must not be null.");
        if (arguments == null)
            throw new IllegalArgumentException("Element arguments must not be null.");
        this.trace = trace;
        this.method = method;
        this.typeArguments = typeArguments;
        this.receiver = receiver;
        this.arguments = arguments;
        this.tuplesEliminated = tuplesEliminated;
        typeArguments.setParent(this);
        receiver.setParent(this);
        arguments.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.ast.Element trace;
    public void setTrace(de.peeeq.wurstscript.ast.Element trace) {
        if (trace == null) throw new IllegalArgumentException();
        this.trace = trace;
    } 
    public de.peeeq.wurstscript.ast.Element getTrace() { return trace; }

    private ImMethod method;
    public void setMethod(ImMethod method) {
        if (method == null) throw new IllegalArgumentException();
        this.method = method;
    } 
    public ImMethod getMethod() { return method; }

    private ImTypeArguments typeArguments;
    public void setTypeArguments(ImTypeArguments typeArguments) {
        if (typeArguments == null) throw new IllegalArgumentException();
        this.typeArguments.setParent(null);
        typeArguments.setParent(this);
        this.typeArguments = typeArguments;
    } 
    public ImTypeArguments getTypeArguments() { return typeArguments; }

    private ImExpr receiver;
    public void setReceiver(ImExpr receiver) {
        if (receiver == null) throw new IllegalArgumentException();
        this.receiver.setParent(null);
        receiver.setParent(this);
        this.receiver = receiver;
    } 
    public ImExpr getReceiver() { return receiver; }

    private ImExprs arguments;
    public void setArguments(ImExprs arguments) {
        if (arguments == null) throw new IllegalArgumentException();
        this.arguments.setParent(null);
        arguments.setParent(this);
        this.arguments = arguments;
    } 
    public ImExprs getArguments() { return arguments; }

    private boolean tuplesEliminated;
    public void setTuplesEliminated(boolean tuplesEliminated) {
        this.tuplesEliminated = tuplesEliminated;
    } 
    public boolean getTuplesEliminated() { return tuplesEliminated; }

    public Element get(int i) {
        switch (i) {
            case 0: return typeArguments;
            case 1: return receiver;
            case 2: return arguments;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = typeArguments; setTypeArguments((ImTypeArguments) newElem); return oldElem;
            case 1: oldElem = receiver; setReceiver((ImExpr) newElem); return oldElem;
            case 2: oldElem = arguments; setArguments((ImExprs) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.typeArguments);
        action.accept(this.receiver);
        action.accept(this.arguments);
    }
    public int size() {
        return 3;
    }
    @Override public ImMethodCall copy() {
        ImMethodCall result = new ImMethodCallImpl(trace, method, (ImTypeArguments) this.typeArguments.copy(), (ImExpr) this.receiver.copy(), (ImExprs) this.arguments.copy(), tuplesEliminated);
        return result;
    }

    @Override public ImMethodCall copyWithRefs() {
        ImMethodCall res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        typeArguments.clearAttributes();
        receiver.clearAttributes();
        arguments.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(ImMemberOrMethodAccess.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(ImMemberOrMethodAccess.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    @Override public <T> T match(ElementWithTrace.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(ElementWithTrace.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    @Override public <T> T match(ImExprOpt.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(ImExprOpt.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    @Override public <T> T match(ImStmt.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(ImStmt.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    @Override public <T> T match(ImClassRelatedExpr.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(ImClassRelatedExpr.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    @Override public <T> T match(ImPrintable.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(ImPrintable.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    @Override public <T> T match(ImExpr.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(ImExpr.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_ImMethodCall(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_ImMethodCall(this);
    }

    public boolean structuralEquals(Element e) {
        if (e instanceof ImMethodCall) {
            ImMethodCall o = (ImMethodCall) e;
            return this.method == o.getMethod()
                && this.typeArguments.structuralEquals(o.getTypeArguments())
                && this.receiver.structuralEquals(o.getReceiver())
                && this.arguments.structuralEquals(o.getArguments())
                && java.util.Objects.equals(tuplesEliminated, o.getTuplesEliminated());
        } else {
            return false;
        }
    }
    /** */
    public void print(java.lang.Appendable sb, int indent) {
        de.peeeq.wurstscript.translation.imtranslation.ImPrinter.print((ImMethodCall)this, sb, indent);
    }
    /** */
    public String toString() {
        return de.peeeq.wurstscript.translation.imtranslation.ImPrinter.asString((ImMethodCall)this);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.Flatten.Result flatten(de.peeeq.wurstscript.translation.imtranslation.ImTranslator translator, de.peeeq.wurstscript.jassIm.ImFunction f) {
        return de.peeeq.wurstscript.translation.imtranslation.Flatten.flatten((ImMethodCall)this, translator, f);
    }
    /** */
    public de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevel attrPurity() {
        return de.peeeq.wurstscript.translation.imtranslation.purity.PurityLevels.calculate((ImMethodCall)this);
    }
    /** */
    public void translate(java.util.List<de.peeeq.wurstscript.jassAst.JassStatement> stmts, de.peeeq.wurstscript.jassAst.JassFunction f, de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        de.peeeq.wurstscript.translation.imtojass.StatementTranslation.translate((ImMethodCall)this, stmts, f, translator);
    }
    /** */
    public de.peeeq.wurstscript.jassAst.JassExpr translate(de.peeeq.wurstscript.translation.imtojass.ImToJassTranslator translator) {
        return de.peeeq.wurstscript.translation.imtojass.ExprTranslation.translate((ImMethodCall)this, translator);
    }
    /** */
    public ImType attrTyp() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttrType.getType((ImMethodCall)this);
    }
    /** */
    public ImFunction getNearestFunc() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getNearestFunc((ImMethodCall)this);
    }
    /** */
    public void translateStmtToLua(java.util.List<de.peeeq.wurstscript.luaAst.LuaStatement> res, de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        de.peeeq.wurstscript.translation.lua.translation.StmtTranslation.translate((ImMethodCall)this, res, tr);
    }
    /** */
    public de.peeeq.wurstscript.luaAst.LuaExpr translateToLua(de.peeeq.wurstscript.translation.lua.translation.LuaTranslator tr) {
        return de.peeeq.wurstscript.translation.lua.translation.ExprTranslation.translate((ImMethodCall)this, tr);
    }
    /** */
    public void runStatement(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        de.peeeq.wurstscript.intermediatelang.interpreter.RunStatement.run((ImMethodCall)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.intermediatelang.ILconst evaluate(de.peeeq.wurstscript.intermediatelang.interpreter.ProgramState globalState, de.peeeq.wurstscript.intermediatelang.interpreter.LocalState localState) {
        return de.peeeq.wurstscript.intermediatelang.interpreter.EvaluateExpr.eval((ImMethodCall)this, globalState, localState);
    }
    /** */
    public de.peeeq.wurstscript.ast.Element attrTrace() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getTrace((ImMethodCall)this);
    }
    /** */
    public ImProg attrProg() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getProg((ImMethodCall)this);
    }
}
