//generated by abstract-syntax-gen
package de.peeeq.wurstscript.jassIm;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class ImTypeClassFuncImpl implements ImTypeClassFunc{
    ImTypeClassFuncImpl(de.peeeq.wurstscript.ast.Element trace, String name, ImTypeVars typeVariables, ImVars parameters, ImType returnType) {
        if (trace == null)
            throw new IllegalArgumentException("Element trace must not be null.");
        if (name == null)
            throw new IllegalArgumentException("Element name must not be null.");
        if (typeVariables == null)
            throw new IllegalArgumentException("Element typeVariables must not be null.");
        if (parameters == null)
            throw new IllegalArgumentException("Element parameters must not be null.");
        if (returnType == null)
            throw new IllegalArgumentException("Element returnType must not be null.");
        this.trace = trace;
        this.name = name;
        this.typeVariables = typeVariables;
        this.parameters = parameters;
        this.returnType = returnType;
        typeVariables.setParent(this);
        parameters.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private de.peeeq.wurstscript.ast.Element trace;
    public void setTrace(de.peeeq.wurstscript.ast.Element trace) {
        if (trace == null) throw new IllegalArgumentException();
        this.trace = trace;
    } 
    public de.peeeq.wurstscript.ast.Element getTrace() { return trace; }

    private String name;
    public void setName(String name) {
        if (name == null) throw new IllegalArgumentException();
        this.name = name;
    } 
    public String getName() { return name; }

    private ImTypeVars typeVariables;
    public void setTypeVariables(ImTypeVars typeVariables) {
        if (typeVariables == null) throw new IllegalArgumentException();
        this.typeVariables.setParent(null);
        typeVariables.setParent(this);
        this.typeVariables = typeVariables;
    } 
    public ImTypeVars getTypeVariables() { return typeVariables; }

    private ImVars parameters;
    public void setParameters(ImVars parameters) {
        if (parameters == null) throw new IllegalArgumentException();
        this.parameters.setParent(null);
        parameters.setParent(this);
        this.parameters = parameters;
    } 
    public ImVars getParameters() { return parameters; }

    private ImType returnType;
    public void setReturnType(ImType returnType) {
        if (returnType == null) throw new IllegalArgumentException();
        this.returnType = returnType;
    } 
    public ImType getReturnType() { return returnType; }

    public Element get(int i) {
        switch (i) {
            case 0: return typeVariables;
            case 1: return parameters;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = typeVariables; setTypeVariables((ImTypeVars) newElem); return oldElem;
            case 1: oldElem = parameters; setParameters((ImVars) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.typeVariables);
        action.accept(this.parameters);
    }
    public int size() {
        return 2;
    }
    @Override public ImTypeClassFunc copy() {
        ImTypeClassFunc result = new ImTypeClassFuncImpl(trace, name, (ImTypeVars) this.typeVariables.copy(), (ImVars) this.parameters.copy(), returnType);
        return result;
    }

    @Override public ImTypeClassFunc copyWithRefs() {
        ImTypeClassFunc res = copy();
        return res;
    }

    @Override public void clearAttributes() {
        typeVariables.clearAttributes();
        parameters.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_ImTypeClassFunc(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_ImTypeClassFunc(this);
    }

    public boolean structuralEquals(Element e) {
        if (e instanceof ImTypeClassFunc) {
            ImTypeClassFunc o = (ImTypeClassFunc) e;
            return java.util.Objects.equals(name, o.getName())
                && this.typeVariables.structuralEquals(o.getTypeVariables())
                && this.parameters.structuralEquals(o.getParameters())
                && this.returnType == o.getReturnType();
        } else {
            return false;
        }
    }
    /** */
    public String toString() {
        return de.peeeq.wurstscript.translation.imtranslation.ImPrinter.asString((ImTypeClassFunc)this);
    }
    /** */
    public ImFunction getNearestFunc() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getNearestFunc((ImTypeClassFunc)this);
    }
    /** */
    public de.peeeq.wurstscript.ast.Element attrTrace() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getTrace((ImTypeClassFunc)this);
    }
    /** */
    public ImProg attrProg() {
        return de.peeeq.wurstscript.translation.imtojass.ImAttributes.getProg((ImTypeClassFunc)this);
    }
}
