//generated by abstract-syntax-gen
package de.peeeq.wurstscript.luaAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class LuaAssignmentImpl implements LuaAssignment{
    LuaAssignmentImpl(LuaExpr left, LuaExpr right) {
        if (left == null)
            throw new IllegalArgumentException("Element left must not be null.");
        if (right == null)
            throw new IllegalArgumentException("Element right must not be null.");
        this.left = left;
        this.right = right;
        left.setParent(this);
        right.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private LuaExpr left;
    public void setLeft(LuaExpr left) {
        if (left == null) throw new IllegalArgumentException();
        this.left.setParent(null);
        left.setParent(this);
        this.left = left;
    } 
    public LuaExpr getLeft() { return left; }

    private LuaExpr right;
    public void setRight(LuaExpr right) {
        if (right == null) throw new IllegalArgumentException();
        this.right.setParent(null);
        right.setParent(this);
        this.right = right;
    } 
    public LuaExpr getRight() { return right; }

    public Element get(int i) {
        switch (i) {
            case 0: return left;
            case 1: return right;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = left; setLeft((LuaExpr) newElem); return oldElem;
            case 1: oldElem = right; setRight((LuaExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.left);
        action.accept(this.right);
    }
    public int size() {
        return 2;
    }
    @Override public LuaAssignment copy() {
        LuaAssignment result = new LuaAssignmentImpl((LuaExpr) this.left.copy(), (LuaExpr) this.right.copy());
        return result;
    }

    @Override public LuaAssignment copyWithRefs() {
        LuaAssignment res = copy();
        Element self = this;
        res.accept(new Element.DefaultVisitor() {
            @Override public void visit(LuaExprMethodCall e) {
                super.visit(e);
                // check reference method
                {
                    Element elem = e.getMethod();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setMethod((LuaMethod) res.followPath(self.pathTo(e.getMethod())));
                    }
                }
            }
            @Override public void visit(LuaExprFunctionCall e) {
                super.visit(e);
                // check reference func
                {
                    Element elem = e.getFunc();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setFunc((LuaFunction) res.followPath(self.pathTo(e.getFunc())));
                    }
                }
            }
            @Override public void visit(LuaExprVarAccess e) {
                super.visit(e);
                // check reference var
                {
                    Element elem = e.getVar();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setVar((LuaVariable) res.followPath(self.pathTo(e.getVar())));
                    }
                }
            }
            @Override public void visit(LuaExprFuncRef e) {
                super.visit(e);
                // check reference func
                {
                    Element elem = e.getFunc();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setFunc((LuaFunction) res.followPath(self.pathTo(e.getFunc())));
                    }
                }
            }
        });
        return res;
    }

    @Override public void clearAttributes() {
        left.clearAttributes();
        right.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(LuaStatement.Matcher<T> matcher) {
        return matcher.case_LuaAssignment(this);
    }
    @Override public void match(LuaStatement.MatcherVoid matcher) {
        matcher.case_LuaAssignment(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_LuaAssignment(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_LuaAssignment(this);
    }

    @Override public String toString() {
        return "LuaAssignment(" + left + ", " +right+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof LuaAssignment) {
            LuaAssignment o = (LuaAssignment) e;
            return this.left.structuralEquals(o.getLeft())
                && this.right.structuralEquals(o.getRight());
        } else {
            return false;
        }
    }
    /** */
    public void print(StringBuilder sb, int indent) {
        de.peeeq.wurstscript.translation.lua.printing.LuaPrinter.print((LuaAssignment)this, sb, indent);
    }
}
