//generated by abstract-syntax-gen
package de.peeeq.wurstscript.luaAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class LuaExprFieldAccessImpl implements LuaExprFieldAccess{
    LuaExprFieldAccessImpl(LuaExpr receiver, String fieldName) {
        if (receiver == null)
            throw new IllegalArgumentException("Element receiver must not be null.");
        if (fieldName == null)
            throw new IllegalArgumentException("Element fieldName must not be null.");
        this.receiver = receiver;
        this.fieldName = fieldName;
        receiver.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private LuaExpr receiver;
    public void setReceiver(LuaExpr receiver) {
        if (receiver == null) throw new IllegalArgumentException();
        this.receiver.setParent(null);
        receiver.setParent(this);
        this.receiver = receiver;
    } 
    public LuaExpr getReceiver() { return receiver; }

    private String fieldName;
    public void setFieldName(String fieldName) {
        if (fieldName == null) throw new IllegalArgumentException();
        this.fieldName = fieldName;
    } 
    public String getFieldName() { return fieldName; }

    public Element get(int i) {
        switch (i) {
            case 0: return receiver;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = receiver; setReceiver((LuaExpr) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.receiver);
    }
    public int size() {
        return 1;
    }
    @Override public LuaExprFieldAccess copy() {
        LuaExprFieldAccess result = new LuaExprFieldAccessImpl((LuaExpr) this.receiver.copy(), fieldName);
        return result;
    }

    @Override public LuaExprFieldAccess copyWithRefs() {
        LuaExprFieldAccess res = copy();
        Element self = this;
        res.accept(new Element.DefaultVisitor() {
            @Override public void visit(LuaExprMethodCall e) {
                super.visit(e);
                // check reference method
                {
                    Element elem = e.getMethod();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setMethod((LuaMethod) res.followPath(self.pathTo(e.getMethod())));
                    }
                }
            }
            @Override public void visit(LuaExprFunctionCall e) {
                super.visit(e);
                // check reference func
                {
                    Element elem = e.getFunc();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setFunc((LuaFunction) res.followPath(self.pathTo(e.getFunc())));
                    }
                }
            }
            @Override public void visit(LuaExprVarAccess e) {
                super.visit(e);
                // check reference var
                {
                    Element elem = e.getVar();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setVar((LuaVariable) res.followPath(self.pathTo(e.getVar())));
                    }
                }
            }
            @Override public void visit(LuaExprFuncRef e) {
                super.visit(e);
                // check reference func
                {
                    Element elem = e.getFunc();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setFunc((LuaFunction) res.followPath(self.pathTo(e.getFunc())));
                    }
                }
            }
        });
        return res;
    }

    @Override public void clearAttributes() {
        receiver.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(LuaStatement.Matcher<T> matcher) {
        return matcher.case_LuaExprFieldAccess(this);
    }
    @Override public void match(LuaStatement.MatcherVoid matcher) {
        matcher.case_LuaExprFieldAccess(this);
    }

    @Override public <T> T match(LuaExpr.Matcher<T> matcher) {
        return matcher.case_LuaExprFieldAccess(this);
    }
    @Override public void match(LuaExpr.MatcherVoid matcher) {
        matcher.case_LuaExprFieldAccess(this);
    }

    @Override public <T> T match(LuaExprOpt.Matcher<T> matcher) {
        return matcher.case_LuaExprFieldAccess(this);
    }
    @Override public void match(LuaExprOpt.MatcherVoid matcher) {
        matcher.case_LuaExprFieldAccess(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_LuaExprFieldAccess(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_LuaExprFieldAccess(this);
    }

    @Override public String toString() {
        return "LuaExprFieldAccess(" + receiver + ", " +fieldName+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof LuaExprFieldAccess) {
            LuaExprFieldAccess o = (LuaExprFieldAccess) e;
            return this.receiver.structuralEquals(o.getReceiver())
                && java.util.Objects.equals(fieldName, o.getFieldName());
        } else {
            return false;
        }
    }
    /** */
    public void print(StringBuilder sb, int indent) {
        de.peeeq.wurstscript.translation.lua.printing.LuaPrinter.print((LuaExprFieldAccess)this, sb, indent);
    }
}
