//generated by abstract-syntax-gen
package de.peeeq.wurstscript.luaAst;
import java.util.*;

@SuppressWarnings({"cast", "unused", "rawtypes"})
class LuaMethodImpl implements LuaMethod{
    LuaMethodImpl(LuaExpr receiver, String name, LuaParams params, LuaStatements body) {
        if (receiver == null)
            throw new IllegalArgumentException("Element receiver must not be null.");
        if (name == null)
            throw new IllegalArgumentException("Element name must not be null.");
        if (params == null)
            throw new IllegalArgumentException("Element params must not be null.");
        if (body == null)
            throw new IllegalArgumentException("Element body must not be null.");
        this.receiver = receiver;
        this.name = name;
        this.params = params;
        this.body = body;
        receiver.setParent(this);
        params.setParent(this);
        body.setParent(this);
    }

    private Element parent;
    public Element getParent() { return parent; }
    public void setParent(Element parent) {
        if (parent != null && this.parent != null) {
            throw new Error("Cannot change parent of element " + this.getClass().getSimpleName() + ", as it is already used in another tree."
                + "Use the copy method to create a new tree or remove the tree from its old parent or set the parent to null before moving the tree. ");
        }
        this.parent = parent;
    }

    public void replaceBy(Element other) {
        if (parent == null)
            throw new RuntimeException("Node not attached to tree.");
        for (int i=0; i<parent.size(); i++) {
            if (parent.get(i) == this) {
                parent.set(i, other);
                return;
            }
        }
    }

    private LuaExpr receiver;
    public void setReceiver(LuaExpr receiver) {
        if (receiver == null) throw new IllegalArgumentException();
        this.receiver.setParent(null);
        receiver.setParent(this);
        this.receiver = receiver;
    } 
    public LuaExpr getReceiver() { return receiver; }

    private String name;
    public void setName(String name) {
        if (name == null) throw new IllegalArgumentException();
        this.name = name;
    } 
    public String getName() { return name; }

    private LuaParams params;
    public void setParams(LuaParams params) {
        if (params == null) throw new IllegalArgumentException();
        this.params.setParent(null);
        params.setParent(this);
        this.params = params;
    } 
    public LuaParams getParams() { return params; }

    private LuaStatements body;
    public void setBody(LuaStatements body) {
        if (body == null) throw new IllegalArgumentException();
        this.body.setParent(null);
        body.setParent(this);
        this.body = body;
    } 
    public LuaStatements getBody() { return body; }

    public Element get(int i) {
        switch (i) {
            case 0: return receiver;
            case 1: return params;
            case 2: return body;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }
    public Element set(int i, Element newElem) {
        Element oldElem;
        switch (i) {
            case 0: oldElem = receiver; setReceiver((LuaExpr) newElem); return oldElem;
            case 1: oldElem = params; setParams((LuaParams) newElem); return oldElem;
            case 2: oldElem = body; setBody((LuaStatements) newElem); return oldElem;
            default: throw new IllegalArgumentException("Index out of range: " + i);
        }
    }

    @Override
    public void forEachElement(java.util.function.Consumer<? super Element> action) {
        action.accept(this.receiver);
        action.accept(this.params);
        action.accept(this.body);
    }
    public int size() {
        return 3;
    }
    @Override public LuaMethod copy() {
        LuaMethod result = new LuaMethodImpl((LuaExpr) this.receiver.copy(), name, (LuaParams) this.params.copy(), (LuaStatements) this.body.copy());
        return result;
    }

    @Override public LuaMethod copyWithRefs() {
        LuaMethod res = copy();
        Element self = this;
        res.accept(new Element.DefaultVisitor() {
            @Override public void visit(LuaExprMethodCall e) {
                super.visit(e);
                // check reference method
                {
                    Element elem = e.getMethod();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setMethod((LuaMethod) res.followPath(self.pathTo(e.getMethod())));
                    }
                }
            }
            @Override public void visit(LuaExprFunctionCall e) {
                super.visit(e);
                // check reference func
                {
                    Element elem = e.getFunc();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setFunc((LuaFunction) res.followPath(self.pathTo(e.getFunc())));
                    }
                }
            }
            @Override public void visit(LuaExprVarAccess e) {
                super.visit(e);
                // check reference var
                {
                    Element elem = e.getVar();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setVar((LuaVariable) res.followPath(self.pathTo(e.getVar())));
                    }
                }
            }
            @Override public void visit(LuaExprFuncRef e) {
                super.visit(e);
                // check reference func
                {
                    Element elem = e.getFunc();
                    while (elem != self && elem != null) {
                        elem = elem.getParent();
                    }
                    if (elem == self) {
                        e.setFunc((LuaFunction) res.followPath(self.pathTo(e.getFunc())));
                    }
                }
            }
        });
        return res;
    }

    @Override public void clearAttributes() {
        receiver.clearAttributes();
        params.clearAttributes();
        body.clearAttributes();
        clearAttributesLocal();
    }
    @Override public void clearAttributesLocal() {
    }
    @Override public void accept(Visitor v) {
        v.visit(this);
    }
    @Override public <T> T match(LuaDefinition.Matcher<T> matcher) {
        return matcher.case_LuaMethod(this);
    }
    @Override public void match(LuaDefinition.MatcherVoid matcher) {
        matcher.case_LuaMethod(this);
    }

    @Override public <T> T match(LuaStatement.Matcher<T> matcher) {
        return matcher.case_LuaMethod(this);
    }
    @Override public void match(LuaStatement.MatcherVoid matcher) {
        matcher.case_LuaMethod(this);
    }

    @Override public <T> T match(Element.Matcher<T> matcher) {
        return matcher.case_LuaMethod(this);
    }
    @Override public void match(Element.MatcherVoid matcher) {
        matcher.case_LuaMethod(this);
    }

    @Override public String toString() {
        return "LuaMethod(" + receiver + ", " +name + ", " +params + ", " +body+")";
    }
    public boolean structuralEquals(Element e) {
        if (e instanceof LuaMethod) {
            LuaMethod o = (LuaMethod) e;
            return this.receiver.structuralEquals(o.getReceiver())
                && java.util.Objects.equals(name, o.getName())
                && this.params.structuralEquals(o.getParams())
                && this.body.structuralEquals(o.getBody());
        } else {
            return false;
        }
    }
    /** */
    public void print(StringBuilder sb, int indent) {
        de.peeeq.wurstscript.translation.lua.printing.LuaPrinter.print((LuaMethod)this, sb, indent);
    }
}
